<?php
$hidebanner=true;
include_once("publiceditable.php");

function read_stream($p)
{ $s=""; while(!feof($p)) $s .= fread($p,8192); return $s;
}

function patch($old,$patch)
{ // applies the patch and returns the new version
  $oldfn = tempnam(".","VPOLD"); write_file($oldfn,$old);
  $patfn = tempnam(".","VPPAT"); write_file($patfn,$patch);
  $proc = proc_open('patch --silent '.escapeshellarg($oldfn).' '.escapeshellarg($patfn),
     array(0=>array("pipe","r"),1=>array("pipe","w"),2=>array("pipe","w")),$p);
  if (!is_resource($proc)) {unlink($oldfn); unlink($patfn); exitmsg("500 Server error","Patch failure");}
  fclose($p[0]); fclose($p[1]); $errs=read_stream($p[2]); fclose($p[2]);
  proc_close($proc);
  $new=file_get_contents($oldfn);
  unlink($patfn); unlink($oldfn); unlink($oldfn.".orig");
  if (strlen($errs)!=0) exitmsg("500 Server error","Patch failure: ".$errs);
  return $new;
}

function diff($old,$new)
{ // returns a "patch string" saying how to update from old to new
  $oldfn = tempnam(".","VDOLD"); write_file($oldfn,$old);
  $newfn = tempnam(".","VDNEW"); write_file($newfn,$new);
  $proc = proc_open('diff '.escapeshellarg($oldfn).' '.escapeshellarg($newfn),
     array(0=>array("pipe","r"),1=>array("pipe","w"),2=>array("pipe","w")),$p);
  if (!is_resource($proc)) {unlink($oldfn); unlink($newfn); exitmsg("500 Server error","Diff failure");}
  fclose($p[0]);
  $diff = read_stream($p[1]); fclose($p[1]);
  $errs  = read_stream($p[2]); fclose($p[2]);
  proc_close($proc); unlink($newfn); unlink($oldfn);
  if (strlen($errs)!=0) exitmsg("500 Server error","Diff failure: ".$errs);
  return $diff;
}


function load_log($logfn)
{ if (file_exists($logfn)) $ss = file($logfn); else $ss = array();
  $log=array(); $h=array();
  foreach ($ss as $s)
  { if ($s=="") continue;
    if ($s[0]!='*') {$h[$h['type']] .= $s; continue;}
    if (count($h)>0) array_push($log,$h);
    $r = preg_match('/^\*([^\t]*)\tuser=([^\t]*)\tcrc32=(\d*)\ttime=([^\t]*)\txpath=([^\t]*)\tsummary=(.*)\n$/',$s,$m);
    if ($r!=1) exitmsg("500 Server error","Log failure: ".$s);
    $h=array("crc32"=>$m[3], "time"=>$m[4], "xpath"=>$m[5], "summary"=>$m[6],
             "type"=>$m[1], $m[1]=>"", "user"=>$m[2]);
  }
  if (count($h)>0) array_push($log,$h);
  return $log;
}


// ***********************************************


if (isset($REQ['dir']))
{ ensure('path',isset($path));
  $files = array();
  $dh =@opendir($path);
  if (!$dh) exitmsg("400 Bad request","Error opening '".$path."'");
  while (false !== ($fn = readdir($dh))) $files[]=$fn;
  sort($files);
  foreach ($files as $fn)
  { //if (is_link($path.$fn)) continue;
    if (is_dir($path.$fn)) {echo "dir:".$fn."\r\n"; continue;}
    $size = @getimagesize($path.$fn);
    if ($size) echo "fnsize:".$size[0].",".$size[1].",".$fn."\r\n";
    else echo "fn:".$fn."\r\n";
  }
  exit();
}


if (isset($REQ['upload']))
{ ensure('path',isset($path));
  ensure('upfile',isset($_FILES['upfile']));
  $file = basename($_FILES['upfile']['name']); // e.g. "a.gif"
  if ($file=='.' || $file=='..' || preg_match('/\\//',$file || $file=='')) exitmsg("400 Bad reqest","File '".$file."' not allowed");
  $r = @move_uploaded_file($_FILES['upfile']['tmp_name'], $path.$file);
  if (!$r) exitmsg("500 Server error","Failed to get file '".$file."'");
  chmod($path.$file,0666);
  $size = @getimagesize($path.$file);
  if ($size) echo "fnsize:".$size[0].",".$size[1].",".$file;
  else echo "fn:".$file;
  exit();
}



if (isset($REQ['newpage']))
{ ensure('path',isset($path));
  ensure('file',isset($file));
  ensure('value',isset($value));
  if (@file_exists($path.$file)) exitmsg("500 Server error","File already exists");
  if ($value=='FOLDER') mkdir($path.$file);
  else {write_file($path.$file, $value); chmod($path.$file,0666);}
  echo "editable:newpage";
  exit();
}

if (isset($REQ['delete']))
{ ensure('path',isset($path));
  ensure('file',isset($file));
  if (!file_exists($path.$file)) exitmsg("400 Bad request","'".$path.$file."' not found");
  if (!@is_writable($path) || !@is_dir($path)) exitmsg("500 Server error","Directory '".$path."' is not writeable by the webserver. chmod 777.");
  $isdir = @is_dir($path.$file) && !@is_link($path.$file);
  if (!$isdir) $r = @unlink($path.$file);
  else
  { $content=false; $r=@opendir($path.$file); 
    while ($r && false!==($fn=readdir($r))) if ($fn!='.' && $fn!='..') $content=$fn;
    if ($r) closedir($r);
    if ($r && $content) exitmsg("400 Bad request","Directory is not empty... ".$content);
    if ($r) $r = @rmdir($path.$file);
  }
  if (!$r) exitmsg("500 Server error","Unable to delete '".$path.$file."'");
  echo "editable:delete";
  exit();
}


if (isset($REQ['log']))
{ ensure('file',isset($file));
  ensure('path',isset($path));
  ensure('xpath',isset($xpath));
  $log = load_log($path.$file.".log");
  foreach ($log as $h)
  { $len=strlen($xpath); $len2=strlen($h["xpath"]); if ($len2<$len) $len=$len2;
    if ($xpath!='*' && $h["xpath"]!='*' && substr($h["xpath"],0,$len)!=substr($xpath,0,$len)) continue;
    echo $h["time"]."\t";
    if ($h["user"]!="") echo "[".$h['user']."] ";
    echo $h["summary"]."\n";
  }
  exit();
}


if (isset($REQ['set']) || isset($REQ['get']))
{ $getting = isset($REQ['get']);
  $ver = isset($REQ['ver']);
  ensure('file',isset($file));
  ensure('path',isset($path));
  ensure('xpath',isset($xpath));
  ensure('innerouter',isset($innerouter));
  if (!$getting) ensure('value',isset($value));
  if (!@is_file($path.$file)) exitmsg("400 Bad request","File '".$path.$file."' not found");
  if (!@is_writeable($path.$file)) exitmsg("500 Server error","File '".$path.$file."' not writable by the webserver. chmod 666.");
  if ($xpath=='/' && $innerouter!='outer') exitmsg("400 Bad request","xpath=/ requires innerouter=outer");
  $log = load_log($path.$file.".log");
  if (!isset($REQ['ver']) || !$getting)
  { $old = @file_get_contents($path.$file);
  }
  else
  { $texti=-1; $veri=-1;
    for ($i=0; $i<count($log); $i++)
    { if ($log[$i]['type']=='text') $texti=$i;
      if ($log[$i]['time']==$REQ['ver']) {$veri=$i; break;}
    }
    if ($veri==-1) exitmsg("400 Bad request","Version ".$REQ['ver']." not found");
    $old=""; if ($texti!=-1) $old=$log[$texti]['text'];
    for ($i=$texti+1; $i<=$veri; $i++) $old=patch($old,$log[$i]['patch']);
  }
  if (!$old || strlen($old)==0) exitmsg("500 Server error","File '".$path.$file."' is empty");
  $oldcrc = sprintf("%u",crc32($old)); $oldtime=filemtime($path.$file);
  
  if ($xpath!='/') $tagpos = get_tagpos($old,$xpath);
  else $tagpos = array('.innerStart'=>0, '.outerStart'=>0, '.innerEnd'=>strlen($old), '.outerEnd'=>strlen($old));
  //
  $innerStart=$tagpos['.innerStart']; $innerEnd=$tagpos['.innerEnd'];
  $outerStart=$tagpos['.outerStart']; $outerEnd=$tagpos['.outerEnd'];

  if ($getting)
  { if ($innerouter=='inner') echo substr($old,$innerStart,$innerEnd-$innerStart);
    else echo substr($old,$outerStart,$outerEnd-$outerStart);
    exit();
  }
  if ($innerouter=='inner') $new = substr($old,0,$innerStart) . $value . substr($old,$innerEnd);
  else $new = substr($old,0,$outerStart) . $value . substr($old,$outerEnd);
  $diff = diff($old,$new);
  if ($diff=="") {echo "editable:set"; exit();}
  write_file($path.$file,$new);
  $newcrc=sprintf("%u",crc32($new)); $newtime=filemtime($path.$file);
  $newuser = $_SERVER['REMOTE_USER']; if (!isset($newuser)) $newuser="";

  // Do we need to save the entire previous state of the file?
  // e.g. in case of external modification
  //
  if ((count($log)==0 || $log[count($log)-1]["crc32"]!=$oldcrc) && $old!="")
  { $h = array("type"=>"text", "crc32"=>$oldcrc, "time"=>date("r",$oldtime),
    "xpath"=>"*", "summary"=>"", "text"=>$old, "user"=>"");
    array_push($log, $h);
  }

  // Make a summary of the current change
  //
  $sum=""; $adds=""; $rems=""; $changes=explode("\n",$diff);
  foreach ($changes as $c)
  { if ($c=="") continue;
    else if ($c[0]=='<') $rems .= substr($c,2)." ";
    else if ($c[0]=='>') $adds .= substr($c,2)." ";
  }
  if ($adds!="") $sum=$adds; else if ($rems!="") $sum="removed ".$rems;
  $longsum = preg_replace('/<[^>]*>/',' ',$sum);
  $longsum = preg_replace('/&[a-zA-Z0-9]*;/',' ',$longsum);
  $longsum = preg_replace('/[<>&]/',' ',$longsum);
  if (strlen($longsum)>1000) $longsum=substr($longsum,0,1000)."...";
  if (strlen($sum)>100) $sum=substr($sum,0,100)."...";

  // Append to the log, either as a "patch" or as a full-text
  //
  $lasttext = 1;
  for ($i=0; $i<count($log); $i++) if ($log[$i]["type"]=="text") $lasttext=$i;
  $h = array("crc32"=>$newcrc, "time"=>date("r",$newtime), "xpath"=>$xpath,
             "summary"=>$sum, "user"=>$newuser);
  if ($i==-1 || $i+50<count($log)) {$h["type"]="text"; $h["text"]=$new;}
  else {$h["type"]="patch"; $h["patch"]=$diff;}
  array_push($log, $h);

  // And save it
  $s = "";
  foreach ($log as $h)
  { $s .= "*".$h['type']."\tuser=".$h['user']."\tcrc32=".$h['crc32'];
    $s .= "\ttime=".$h['time']."\txpath=".$h['xpath']."\tsummary=".$h['summary'];
    $s .= "\n".$h[$h['type']];
  }
  write_file($path.$file.".log",$s);

  notify($longsum,false);

  echo "editable:set";
  exit();
}



header("HTTP/1.1 400 Bad request");
echo "EDITABLE WEB -- Ajax server\n".
     "0. ? -- prints usage instructions\n".
     "1. ?dir&path=/lu/ -- Returns a listing of the files in DOCUMENT_ROOT/lu/, as fn:a.html or fnsize:640,480,a.gif for images\n".
     "2. ?newpage&path=/lu/&file=newfile.html&value=... -- creates a new page DOCUMENT_ROOT/lu/newfile.html\n".
     "3. ?upload&path=/lu/&upfile=... -- uploads the file into DOCUMENT_ROOT/lu/upfile.name, returns up:fn or upsize:x,y,fn\n".
     "4. ?set&path=/lu/&file=a.html&xpath=/div[0]/div[1]&value=... -- modifies the file in DOCUMENT_ROOT/lu/a.html by replacing the contents of the specified div with a value, which should have been uploaded in multipart/binary with no encoding. Returns 'editable:set'.\n".
     "5. ?get&path=/lu/&file=a.html&xpath=/div[1]/table[0]/td[2][&ver=v] -- returns the contents of the div in DOCUMENT_ROOT/lu/a.html.\n".
     "6. ?log&path=/lu/&file=a.html&xpath=/div[0]/pre[2] -- returns a log of past versions.\n".
     "7. ?delete&path=/lu/&file=oldfile.html -- deletes the file.\n".
     "";
