// The Editable Web v0.2
// (c) 2007 Lucian Wischik


var editable_selected_node;  // the HTML node that's under consideration
var editable_selected_xpath; // /div[1]/table[1]/td, for sending to PHP
var editable_selected_type;  // wisywig,markup,code,public
var editable_furniture_mode; // edit,raw,ajax
var editable_dialog='';      // meta,color,image,link,log,table,waiting
var editable_path, editable_curpath;
var editable_link='http://news.bbc.co.uk';
var editable_table='1,2,2';
var editable_userip='';
var editable_onip=null;      // a callback for when we get the ip
var editable_ctrl=false;     // is the CTRL key down?
var editable_zbase = 10000;
var editable_remotedir='';   // the remote directory we're browsing



var editable_xmlhttp=null, editable_xmlhttp2=null, editable_xmlbusy=false;
//
try
{ editable_xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
  editable_xmlhttp2=new ActiveXObject("Microsoft.XMLHTTP");
}
catch(e)
{ editable_xmlhttp = new XMLHttpRequest();
  editable_xmlhttp2 = new XMLHttpRequest();
}
if(editable_xmlhttp==null)alert("Your browser doesn't support AJAX. Try IE7.");


function xmlanimate()
{ if (!editable_xmlbusy) {setTimeout(xmlanimate,600); return;}
  var s=editable_xmlbusy.innerHTML;
  var r = {'&nbsp;&nbsp;&nbsp;':'.&nbsp;&nbsp;', '.&nbsp;&nbsp;':'..&nbsp;', '..&nbsp;':'...', '...':'&nbsp;&nbsp;&nbsp;'};
  for (var ri in r)
  { var p = s.indexOf(ri); if (p==-1) continue;
    s=s.substring(0,p)+r[ri]; break;
  }
  editable_xmlbusy.innerHTML=s;
  setTimeout(xmlanimate,600);
}
xmlanimate();

function EditableOnResize()
{ var wh=window.innerHeight?window.innerHeight:document.documentElement.clientHeight;
  var ww=window.innerWidth?window.innerWidth:document.documentElement.clientWidth;
  if (wh==window.editable_oldwh && ww==window.editable_oldww) return;
  window.editable_oldwh=wh; window.editable_oldww=ww;
  // Putting a delay here brings sanity into IE's GetBounds computations
  if (!window.resize_timer) {window.resize_timer=true; setTimeout(function(){window.resize_timer=false;ShowFurniture();},1);}
}

function EditableOnKeyDown(e)
{ if (editable_ctrl) return;
  if (!e) e=event; var keycode=(e.keyCode?e.keyCode:e.which);
  if (keycode==17) {editable_ctrl=true; EditableKeyCheck();}
}
function EditableOnKeyUp(e)
{ if (!editable_ctrl) return;
  if (!e) e=event; var keycode=(e.keyCode?e.keyCode:e.which);
  if (keycode==17) {editable_ctrl=false; EditableKeyCheck();}
}
function EditableKeyCheck()
{ if (!editable_selected_node || editable_furniture_mode) return;
  ShowFurniture();
}


function addcomment1(n)
{ while (n!=null && n.getAttribute("ip")!="*") n=n.parentNode;
  if (!n) {alert("Cannot add comments here");}
  function haveip()
  { editable_selected_node=n;
    editable_selected_type='public';
    editable_selected_xpath = ComputeXpath(n);
    control('edit0');
  }
  if (editable_xmlhttp2!=null) editable_onip=haveip; else haveip();
}

function editcomment1(n)
{ alert("To edit your comments, select them and click the blue 'editing' dagger");
}

// We are only interested the document structure boiled down
// to "X-Tags", as follows:
function isxtag(x)
{ return x.tagName=='TD' || x.tagName=='TABLE' || x.tagName=='PRE' || x.tagName=='DIV' || x.tagName=='HEAD' || x.tagName=='BODY';
}

function ComputeXpath(r)
{ var xpath='';
  // We want to built the xpath. But again, for only the document
  // structure as boiled down to X-Tags. GetChildren returns a list
  // of all the (immediate up to xtag) children of n that have tag 'tag':
  //
  function GetChildren(n, tag, oaccum)
  { // leave oaccum blank. We use it just for internal purposes,
    // when doing subchildren
    var accum=oaccum; if (!accum && !isxtag(n) && n.parentNode!=null) alert("GetChildren not on an xtag");
    if (!accum) accum=[];
    if (oaccum)
    { if (n.id && n.id.match(/^editable[\._]/)) return accum;
      if (n.tagName==tag) {accum.push(n); return;}
      if (isxtag(n)) return accum;
    }
    for (var i=0; i<n.childNodes.length; i++)
    { GetChildren(n.childNodes[i],tag,accum);
    }
    return accum;
  }

  while (true)
  { var p=r.parentNode; while (p!=null && p.parentNode!=null && !isxtag(p)) p=p.parentNode;
    if (p==null) break;
    var peers = GetChildren(p,r.tagName);
    var i; for (i=0; i<peers.length; i++)
    { if (IsSameNode(r,peers[i])) {xpath="/"+r.tagName.toLowerCase()+"["+i+"]"+xpath; break;}
    }
    if (i==peers.length) alert("failed to find xpath");
    r=p;
  }
  return xpath;
}




function EditableOnMouseUp(e)
{ if (!e) e=window.event;
  if (editable_furniture_mode!='') return;
  try {var r = GetEditorSelection(window);} catch (e) {}
  if (!r) return;

  for (r=r.commonAncestorNode;;r=r.parentNode)
  { if (r==null) r=document.body;
    if (r.getAttribute) {var ip=r.getAttribute("ip"); if (ip && ip!="*" && ip!=editable_userip) continue;}
    if (r.id && r.id.match(/^editable[_\.]/)) continue;
    if (isxtag(r)) break;
  }
  if (e.ctrlKey) r=document.body;
  editable_selected_node = r;
  editable_selected_xpath = ComputeXpath(r);
  editable_selected_type = (r.tagName=="PRE"?"markup":"wysiwyg");
  if (r.getAttribute("editable")=="markup") editable_selected_type="markup";
  if (r.getAttribute("editable")=="code") editable_selected_type="code";
  if (r.getAttribute("ip")) editable_selected_type="public";
  editable_furniture_mode = '';

  ShowFurniture();
}


function EditableOnBeforeUnload(e)
{ var c=false;
  c |= (document.getElementById("editable.iframe").style.display!='none');
  c |= (document.getElementById("editable.textarea").style.display!='none');
  if (editable_dialog && editable_dialog!='meta') c=true;
  if (editable_dialog=='meta' && (document.getElementById('editable.dialog.meta.title').haschanged || document.getElementById('editable.dialog.meta.description').haschanged || document.getElementById('editable.dialog.meta.keywords').haschanged)) c=true;
  //
  if (c) return "If you navigate away, you'll lose the edits you're making.";
}


function EditableOnScroll()
{ setTimeout(function(){editable_scroll_timer=false;ScrollFurniture();},1);
}



function onEditableLoad()
{
  // Was it a manual load or an automatic cookie-driven one?
  var manual = !document.cookie.match(/^(.*;( )?)?(editable=on)(;.*)?$/);

  // There might be errors on initialization. They lead to a common error-handler
  var initerr=false;

  // First check for the editable script (and save it in global variables)
  editable_curpath = urlsplit(location.href).path;
  editable_path = false;
  var scripts = document.getElementsByTagName("script");
  for (var i=0; i<scripts.length; i++)
  { if (!scripts[i].src) continue;
    var r = urlsplit(scripts[i].src);
    if (r.file.match(/editable1?.js/)) editable_path=r.path;
  }
  if (editable_path===false) {initerr=true; if (manual) alert("Editable script not found");}
  var m = document.cookie.match(/^(.*?; )*?editable.path=([^;]*)/);
  if (!m) editable_remotedir=editable_curpath;
  else editable_remotedir=decodeURIComponent(m[2]);

  // Also check that the document is in standards mode
  if (document.compatMode && document.compatMode=="BackCompat")
  { initerr=true; if (manual) {TryToPutIntoStandardsMode(onEditableFailure);return;}
  }

  // If there was a failure, either TryToPutIntoStandardsMode will have
  // invoked the onEditableFailure continuation after its ajax hijynx,
  // or we'll invoke the continuation right here and now:
  if (initerr) return onEditableFailure();

  // If there was success, set the cookie and up up and away:
  document.cookie = "editable=on; path=/";
  var c=document.getElementById("editable_loader");
  if (c) c.parentNode.removeChild(c);
  if (manual) alert("To edit the page, select some text and click the blue 'Edit' dagger");
  InitializeEditableControls();
}

function onEditableFailure()
{ document.cookie = "editable=off; path=/";

  // Remove the loader's loading-mark. We may create our own later on.
  var c=document.getElementById("editable_loader");
  if (c) c.parentNode.removeChild(c);

  // if it failed to load, then we'll put our own loader mark
  // up there. If the user clicks on it, it'll be in manual, so errors will show.
  var e=document.createElement('div');
  e.innerHTML='<a id="editable_loader" style="top:0;right:3px;position:absolute;font-family:Courier New;font-size:10pt;text-decoration:none;opacity:0.4;'+(navigator.appName=='Netscape'?'':'filter:alpha(opacity=40);')+'" href="javascript:onEditableLoad();">&dagger;</span>';
  document.body.appendChild(e.childNodes[0]);
}


function TryToPutIntoStandardsMode(cc)
{
  // First we'll download the page and see if we can change the DOCTYPE
  // declaration through the magic of regexps.
  // If it's too hard, we'll tell the user what needs to be done and
  // leave it at that. But if we think we can manage it automatically,
  // we'll try.
  var msg = "This page is in 'quirks mode' and can't be edited";


  var req = editable_path+'editable.php?get&innerouter=outer&path='+encodeURIComponent(editable_curpath)+'&file='+encodeURIComponent(urlsplit(location.href).file)+'&xpath=/&random='+Math.floor(Math.random()*99999);
  editable_xmlhttp.open('get',req,true);
  editable_xmlhttp.onreadystatechange = function()
  { if (editable_xmlhttp.readyState!=4) return;
    if (editable_xmlhttp.status!=200) {alert(msg+"\nAttempting to fix it automatically gave this error message:\n"+striptags(editable_xmlhttp.responseText)); return cc();}

    var text = editable_xmlhttp.responseText;
    var mdoct = text.match(/^\s*(<!DOCTYPE[^>]*>)/i);
    var mhtml = text.match(/^\s*<html/i);
    if (!mdoct && !mhtml) {alert(msg+"\nTo put it in standards mode, add an appropriate <!DOCTYPE> declaration"); return cc();}

    var ndoctype = '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">';
    msg+="\nIt can be automatically updated into 'standards mode'\n";
    if (mdoct) msg+="(by changing "+mdoct[1]+" to "+ndoctype+"),\n";
    else msg+="(by adding to the front "+ndoctype+"),\n";
    msg+="though this may change its appearance slightly.\n\n";
    msg+="Do you want the document updated now?";
    var r = confirm(msg); if (!r) return cc();

    if (mdoct) text=text.replace(/^\s*<!DOCTYPE[^>]*>/i,ndoctype);
    else text=text.replace(/^\s*</,ndoctype+'\n<');

    // For some reason, firefox was reusing the previous onreadystatechange
    // rather than the new one. So I create a new object here:
    editable_xmlhttp.abort();
    try {editable_xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");}
    catch(e) {editable_xmlhttp = new XMLHttpRequest();}

    var req = editable_path+'editable.php?set&innerouter=outer&path='+encodeURIComponent(editable_curpath)+'&file='+encodeURIComponent(urlsplit(location.href).file)+'&xpath=/&random='+Math.floor(Math.random()*99999);
    editable_xmlhttp.open('post',req,true);
    editable_xmlhttp.setRequestHeader('Content-Type','application/x-www-form-urlencoded; charset=UTF-8');
    editable_xmlhttp.onreadystatechange = function()
    { if (editable_xmlhttp.readyState!=4) return;
      if (editable_xmlhttp.status!=200 || editable_xmlhttp.responseText!='editable:set')
      { alert(striptags(editable_xmlhttp.responseText)); return cc();
      }
      // Here we think we've done it! Turn the cookie on so that when the page is
      // reloaded it becomes editable.     
      document.cookie = "editable=on; path=/";
      location.reload();
      alert("The page has been changed to 'standards mode'.\nTo edit the page, select some text and click the blue 'edit' dagger.");

    }
    editable_xmlhttp.send('value='+encodeURIComponent(text));


  }
  editable_xmlhttp.send(null);
}



  
function InitializeEditableControls()
{ var c = document.createElement('div'); c.id="editable_container";
  c.style.position="absolute"; c.style.width="0px"; c.style.height="0px";
  c.style.zIndex=editable_zbase;
  //
  var colors = new Array(
  "#000000","#000033","#000066","#000099","#0000CC","#0000FF","#330000","#330033","#330066","#330099","#3300CC",
  "#3300FF","#660000","#660033","#660066","#660099","#6600CC","#6600FF","#990000","#990033","#990066","#990099",
  "#9900CC","#9900FF","#CC0000","#CC0033","#CC0066","#CC0099","#CC00CC","#CC00FF","#FF0000","#FF0033","#FF0066",
  "#FF0099","#FF00CC","#FF00FF","#003300","#003333","#003366","#003399","#0033CC","#0033FF","#333300","#333333",
  "#333366","#333399","#3333CC","#3333FF","#663300","#663333","#663366","#663399","#6633CC","#6633FF","#993300",
  "#993333","#993366","#993399","#9933CC","#9933FF","#CC3300","#CC3333","#CC3366","#CC3399","#CC33CC","#CC33FF",
  "#FF3300","#FF3333","#FF3366","#FF3399","#FF33CC","#FF33FF","#006600","#006633","#006666","#006699","#0066CC",
  "#0066FF","#336600","#336633","#336666","#336699","#3366CC","#3366FF","#666600","#666633","#666666","#666699",
  "#6666CC","#6666FF","#996600","#996633","#996666","#996699","#9966CC","#9966FF","#CC6600","#CC6633","#CC6666",
  "#CC6699","#CC66CC","#CC66FF","#FF6600","#FF6633","#FF6666","#FF6699","#FF66CC","#FF66FF","#009900","#009933",
  "#009966","#009999","#0099CC","#0099FF","#339900","#339933","#339966","#339999","#3399CC","#3399FF","#669900",
  "#669933","#669966","#669999","#6699CC","#6699FF","#999900","#999933","#999966","#999999","#9999CC","#9999FF",
  "#CC9900","#CC9933","#CC9966","#CC9999","#CC99CC","#CC99FF","#FF9900","#FF9933","#FF9966","#FF9999","#FF99CC",
  "#FF99FF","#00CC00","#00CC33","#00CC66","#00CC99","#00CCCC","#00CCFF","#33CC00","#33CC33","#33CC66","#33CC99",
  "#33CCCC","#33CCFF","#66CC00","#66CC33","#66CC66","#66CC99","#66CCCC","#66CCFF","#99CC00","#99CC33","#99CC66",
  "#99CC99","#99CCCC","#99CCFF","#CCCC00","#CCCC33","#CCCC66","#CCCC99","#CCCCCC","#CCCCFF","#FFCC00","#FFCC33",
  "#FFCC66","#FFCC99","#FFCCCC","#FFCCFF","#00FF00","#00FF33","#00FF66","#00FF99","#00FFCC","#00FFFF","#33FF00",
  "#33FF33","#33FF66","#33FF99","#33FFCC","#33FFFF","#66FF00","#66FF33","#66FF66","#66FF99","#66FFCC","#66FFFF",
  "#99FF00","#99FF33","#99FF66","#99FF99","#99FFCC","#99FFFF","#CCFF00","#CCFF33","#CCFF66","#CCFF99","#CCFFCC",
  "#CCFFFF","#FFFF00","#FFFF33","#FFFF66","#FFFF99","#FFFFCC","#FFFFFF");
  var colw=18, colh=Math.ceil(colors.length/colw);
  var cols="<table cellspacing='1' cellpadding='0' style='margin-left:auto; margin-right:auto;'>";
  var coli=0;
  for (var colhi=0; colhi<colh; colhi++)
  { cols+="<tr>";
    for (var colwi=0; colwi<colw; colwi++)
    { if (coli>=colors.length) continue;
      cols+='<td style="background-color:'+colors[coli]+'; width:1em; height:1em; cursor:pointer;" onmousedown="dialog(\'select\',\''+colors[coli]+'\');">&nbsp;</td>';
      coli++;
    }
    cols+="</tr>";
  }
  cols+='<tr><td colspan="'+colw+'"><span style="border:solid thin black; cursor:pointer; font-family:Arial; font-size:small;" onmousedown="dialog(\'select\',\'default\');">default</span></td></tr>';
  cols+="</table>";

  //
  var row1 = "";
  row1 += '<select id="editor.toolbar.formatblock" onchange=\'var e=document.getElementById("editor.toolbar.formatblock"); command("formatblock",e.options[e.selectedIndex].value); e.selectedIndex=0;\'>'+
          '<option value="">[Style]</option>'+
          '<option value="<p>">Normal</option>'+
          '<option value="<h1>">Heading 1</option>'+
          '<option value="<h2>">Heading 2</option>'+
          '<option value="<h3>">Heading 3</option>'+
          '<option value="<pre>">Typewriter</option>'+
          '</select> '
  row1 += '<select id="editor.toolbar.fontname" onchange=\'var e=document.getElementById("editor.toolbar.fontname"); command("fontname",e.options[e.selectedIndex].value); e.selectedIndex=0;\'>'+
          '<option value="">[Font]</option>'+
          '<option value="Arial, Helvetica, sans-serif">Arial</option>'+
          '<option value="\'Arial Black\', Helvetica, sans-serif">Arial Black</option>'+
          '<option value="\'Comic Sans MS\', cursive">Comic Sans</option>'+
          '<option value="\'Courier New\', Courier, monospace">Courier New</option>'+
          '<option value="Georgia, serif">Georgia</option>'+
          '<option value="Impact, serif">Impact</option>'+
          '<option value="\'Times New Roman\',Times,serif">Times New Roman</option>'+
          '<option value="\'Trebuchet MS\',Arial,Helvetica,sans-serif">Trebuchet MS</option>'+
          '<option value="Verdana, Arial, Helvetica, sans-serif">Verdana</option>'+
          '</select> ';
  row1 += '<select id="editor.toolbar.fontsize" onchange=\'var e=document.getElementById("editor.toolbar.fontsize"); command("fontsize",e.options[e.selectedIndex].value); e.selectedIndex=0;\'>'+
          '<option value="">[Size]</option>'+
          '<option value="1">smallest</option>'+
          '<option value="2">small</option>'+
          '<option value="3">normal</option>'+
          '<option value="4">large</option>'+
          '<option value="5">largest</option>'+
          '</select> ';
  var row2 = "";
  var cmds = {'bold':'command("bold");',
              'italic':'command("italic");',
              'underline':'command("underline");',
              'strikethrough':'command("strikethrough");',
              'superscript':'command("superscript");',
              'subscript':'command("subscript");',
              'justify-left':'command("justifyleft");',
              'justify-center':'command("justifycenter");',
              'justify-right':'command("justifyright");',
              'justify-full':'command("justifyfull");',
              'horizontal-rule':'command("inserthorizontalrule");',
              'numbered-list':'command("insertorderedlist");',
              'bullet-points':'command("insertunorderedlist");',
              'outdent':'command("outdent");',
              'indent':'command("indent");',
              'text-color':'textcolor();',
              'background-color':'backgroundcolor();',
              'insert-link':'insertlink();',
              'insert-image':'insertimage();',
              'insert-table':'inserttable();',
              'insert-code':'insertcode();',
              'undo':'command("undo");',
              'redo':'command("redo");',
              'remove-format':'removeformat();'};
  for (var key in cmds)
  { row2 += '<img id="editor.toolbar.'+key+'" src="'+editable_path+key+'.gif" style="cursor:pointer; width:25px; height:24px; margin:0px; border:0px; padding:0px; float:none;" alt="'+key+'" title="'+key+'" '+

            'onmouseover="document.getElementById(\'editor.toolbar.'+key+'\').style.background=\'lightskyblue\';" '+
            'onmouseout="document.getElementById(\'editor.toolbar.'+key+'\').style.background=\'\';" '+
            'onmousedown=\''+cmds[key]+'\' '+
            '/> ';
  }
  var toolbar='<table cellpadding=2 cellspacing=0 style="background-color:lightslategray; width:100%;"><tr><td>'+row1+'</td></tr><tr><td>'+row2+'</td></tr></table>';

  // **********************************

  var cs = '<div id="editable.toolbar" style="position:fixed; top:0px; left:0px; width:100%; z-index:'+(editable_zbase+5)+'; display:none;">'+toolbar+'</div> '+
           '<div id="editable.dialog.back0" style="position:fixed; top:0px; left:0px; width:100%; height:100%; z-index:'+(editable_zbase+6)+'; background-color:yellow; '+filter(0)+' display:none;" onmousedown="dialog(\'cancel\');"></div> '+
           '<div id="editable.dialog.back" style="position:fixed; top:0px; left:0px; width:400px; height:400px; z-index:'+(editable_zbase+7)+'; background-color:lightslategray; display:none;">'+
             '<div id="editable.dialog.waiting" style="width:100%; height:90%; line-height:15ex; color:black; font-weight:bold; font-size:large; text-align:center; display:none;">WAITING</div>'+
             '<div id="editable.dialog.color" style="width:100%; height:90%;">'+
             cols+
             '</div>'+
             '<div id="editable.dialog.table" style="width:100%; height:90%;">'+
               'Rows &uarr;&darr; <input id="editable.dialog.table.h" type="text" size="5" onchange="dialog(\'table\',\'preview\');" onkeyup="dialog(\'table\',\'preview\');"/> '+
               '&nbsp;&nbsp; &times; &nbsp;&nbsp; '+
               'Columns &harr; <input id="editable.dialog.table.w" type="text" size="5"/ onchange="dialog(\'table\',\'preview\');" onkeyup="dialog(\'table\',\'preview\');"/> '+
               '&nbsp;&nbsp; &nbsp;&nbsp; '+
               '<input id="editable.dialog.table.borders" type="checkbox" checked onclick="dialog(\'table\',\'preview\');"/> Borders <br/><br/>'+
               '&nbsp; <input type="button" value="Ok" onmousedown="dialog(\'table\',\'submit\');"/> <br/><hr/><br/>'+
               '<div id="editable.dialog.table.preview" style="overflow:auto; width:98%; height:80%; padding:1em;"></div>'+
             '</div>'+
             '<div id="editable.dialog.log" style="width:100%; height:90%;">'+
               '<div id="editable.dialog.log.list" style="overflow:auto; width:98%; height:80%;"></div>'+
             '</div>'+
             '<div id="editable.dialog.link" style="width:100%; height:90%;">'+
               'Url <input id="editable.dialog.link.external" type="text" size="50"/> <input type="button" value="Link..." onmousedown="var i=document.getElementById(\'editable.dialog.link.external\'); dialog(\'select\',i.value);"/> <hr/>'+
               'New page name '+
               '<input id="editable.dialog.link.create" type="text" size="20"/> '+
               '<select id="editable.dialog.link.createtype"><option value="copy">copy of this page</option> <option value="blank">new blank page</option><option value="comments">blank page with comments</option></select> '+
               '<input type="button" value="Create..." onmousedown="var i=document.getElementById(\'editable.dialog.link.create\'); var e=document.getElementById(\'editable.dialog.link.createtype\'); dialog(\'create_link\',[i.value, e.options[e.selectedIndex].value]);"/> <hr/>'+
               '<div id="editable.dialog.link.list" style="overflow:auto; width:98%; height:80%;"></div>'+
             '</div>'+
             '<div id="editable.dialog.meta" style="width:100%; height:90%; padding-left:1em;">'+
               '<br/>Title:<br/><input id="editable.dialog.meta.title" type="text" style="width:90%;" onchange="this.haschanged=true;" onkeydown="this.haschanged=true;"/><br/>'+
               '<br/>Description:<br/><input id="editable.dialog.meta.description" type="text" style="width:90%;" onchange="this.haschanged=true;" onkeydown="this.haschanged=true;"/><br/>'+
               '<br/>Keywords:<br/><input id="editable.dialog.meta.keywords" type="text" style="width:90%;" onchange="this.haschanged=true;" onkeydown="this.haschanged=true;"/><br/>'+
               '<hr style="width:90%; margin-left:-0.2em;"/><input type="button" value="OK" onclick="var r={title:document.getElementById(\'editable.dialog.meta.title\').value, description:document.getElementById(\'editable.dialog.meta.description\').value, keywords:document.getElementById(\'editable.dialog.meta.keywords\').value}; dialog(\'select\',r);"/>'+
               '<p style="margin-top:2em;"><a href="'+editable_path+'" onclick="document.cookie=\'editable.path='+encodeURIComponent(editable_curpath)+'; path=/\';">Manage files...</a></p>'+
               '<p>Editable Web v0.1, July 2007.</p>'+
             '</div>'+
             '<div id="editable.dialog.image" style="width:100%; height:90%;">'+
               '<form id="editable.dialog.image.form" enctype="multipart/form-data" action="'+editable_path+'editable.php?upload&path='+encodeURIComponent(editable_remotedir)+'" method="post" target="editable.dialog.image.iframe" onsubmit="dialog(\'upload_start\');" style="padding-bottom: 1ex; margin-bottom: 1ex; margin-top: 1ex; border-bottom:solid thin black;">\n'+
                 '<label>Upload</label> <input type="file" size="40" name="upfile" /> '+
                 '<input type="submit" value="Upload" /> '+
               '</form>\n'+
               '<iframe id="editable.dialog.image.iframe" name="editable.dialog.image.iframe" style="display:none;" src="about:blank" onload="var i=document.getElementById(\'editable.dialog.image.iframe\').contentWindow.document; if (i.location.href!=\'about:blank\') dialog(\'upload_done\',i.body.textContent?i.body.textContent:i.body.innerText);" ></iframe> '+
               '<div id="editable.dialog.image.list" style="overflow:auto; width:98%; height:80%;"></div>'+
             '</div>'+
             '<div id="editable.dialog.cancel" style="position:absolute; right:5px;">'+
               '<input type="button" value="Cancel" onmousedown="dialog(\'cancel\');"/> '+
             '</div> '+
           '</div> '+
           '<div id="editable.disable" style="position:absolute; background-color:white; color:white; font-weight:bold; font-family:\'Courier New\'; text-align:center; z-index:'+editable_zbase+'; display:none;"></div> '+
           '<iframe id="editable.iframe" frameborder="0" src="about:blank" style="position:absolute; z-index:'+(editable_zbase+1)+'; display:none; border:dotted black 1px; background-color:white;"></iframe> '+
           '<textarea id="editable.textarea" rows="10" cols="10" style="position:absolute; z-index:'+(editable_zbase+1)+'; font-size:9pt; display:none"></textarea> ';

  cs += '<style type="text/css">#editable_controls span {font-family:Courier New; color:black; font-size:10pt; cursor:pointer; margin-right:0.5ex;}</style>'+
        '<div id="editable_controls" style="white-space:nowrap; position:absolute; top:-100px; z-index:'+(editable_zbase+2)+';">'+
        '<span id="editable_controls_edit0" style="background-color:rgb(140,140,220); font-family:Trebuchet MS;" onmousedown="control(\'edit0\');">edit</span>'+
        '<span id="editable_controls_log" style="background-color:rgb(140,140,140);" onmousedown="control(\'log\');" title="revert">&lt;</span>'+
        '<span id="editable_controls_raw" style="background-color:rgb(140,140,220);" onmousedown="control(\'html\');" title="edit">&Dagger;</span>'+
        '<span id="editable_controls_edit" style="background-color:rgb(140,140,220);" onmousedown="control(\'edit\');" title="edit">&dagger;</span>'+
        '<span id="editable_controls_submit" style="background-color:rgb(140,220,140);" onmousedown="control(\'submit\');" title="submit">o</span>'+
        '<span id="editable_controls_cancel" style="background-color:rgb(220,140,140);" onmousedown="control(\'cancel\');" title="cancel">x</span> '+
        '</div>';
  cs += '<div id="editable.meta.controls" style="z-index:'+(editable_zbase+1)+'; position:absolute;top:0px;left:3px;"><a style="font-family:Courier New; text-decoration:none; font-size:10pt; '+filter(0.3)+'" href="javascript:control(\'meta\');">&deg;</a></div>';

  var csfmt = '<style type="text/css">\n'+
        '#editable_container {font-family:"Tahoma MS",Arial,helvetica,sans-serif; font-size:medium; font-weight:normal; color:rgb(48,48,48); margin:0; padding:0; border:0; text-align:left;}\n'+
        '#editable_container table {display:table;}\n'+
        '#editable_container td {text-align:left; width:auto; height:auto; vertical-align:top;}\n'+
        '#editable_container a {color:rgb(80,10,0); text-decoration:underline;}\n'+
        '#editable_container a:visited {color:rgb(80,0,10);}\n'+
        '#editable_container a:hover {background-color:yellow;}\n'+
        '#editable_container a:active {background-color:yellow;}\n'+
        '</style>';


  c.innerHTML = csfmt+cs;
  document.body.insertBefore(c,document.body.childNodes[0]);

  editable_selected_node=null; editable_furniture_mode='';
  ShowFurniture();

  var req = editable_path+'publiceditable.php?ip';
  editable_xmlhttp2.open('get',req,true);
  editable_xmlhttp2.onreadystatechange = function()
  { if (editable_xmlhttp2.readyState!=4) return;
    if (editable_xmlhttp2.status!=200) {alert(striptags(editable_xmlhttp2.responseText)); editable_xmlhttp2=null; return;}
    editable_userip = editable_xmlhttp2.responseText;
    editable_xmlhttp2=null;
    if (editable_onip) editable_onip();
  }
  editable_xmlhttp2.send(null);


  function ev(e,s,f)
  { if (e.addEventListener) e.addEventListener(s,f,false);
    else if (e.attachEvent) e.attachEvent("on"+s,f);
    else e["on"+s]=f;
  }

  window.onbeforeunload = EditableOnBeforeUnload;
  ev(window, "resize", EditableOnResize);
  ev(window, "scroll", EditableOnScroll);
  ev(document, "mouseup", EditableOnMouseUp);
  ev(document, "keydown", EditableOnKeyDown);
  ev(document, "keyup", EditableOnKeyUp);
}


function control(cmd)
{ // cmd = edit0, edit, html, submit, cancel, log, meta, ...
  //
  var e = editable_selected_node;
  var d = document.getElementById("editable.disable");
  var iframe = document.getElementById("editable.iframe");
  var textarea = document.getElementById("editable.textarea");
  //
  // Many of the functions take in the existing text and put it
  // somewhere else. So here are generic routines to get the
  // text (and background color). textassert says whether we
  // really intended that background color, or whether it was
  // just for show.
  var text=""; var textbg=""; var textfg=""; var bgassert=false,fgassert=false;
  //
  if (iframe.style.display!='none')
  { text=ampersandise(iframe.contentWindow.document.body.innerHTML);
    textbg=iframe.contentWindow.document.body.style.backgroundColor;
    textfg=iframe.contentWindow.document.body.style.color;
    bgassert=iframe.getAttribute("editable_bgassert");
    fgassert=iframe.getAttribute("editable_fgassert");
  }
  else if (textarea.style.display!='none')
  { text=textarea.value;
    textbg=textarea.style.backgroundColor;
    textfg=textarea.style.color;
    bgassert=textarea.getAttribute("editable_bgassert");
    fgassert=textarea.getAttribute("editable_fgassert");
  }
  else if (e && e.getAttribute("ip")!="*")
  { if (e.tagName=="BODY") {var c=document.getElementById("editable_container"), p=c.parentNode; p.removeChild(c); text=e.innerHTML; p.appendChild(c);}
    else if (e.tagName=="TABLE") text=GetOuterHTML(e);
    else text=e.innerHTML;
    text=ampersandise(text);
    if (!e.style.backgroundColor) textbg=colorjoin(GetBackgroundColor(e));
    else {textbg=e.style.backgroundColor; bgassert=true;}
    if (!e.style.color) textfg=GetComputedStyle(e,'color');
    else {textfg=e.style.color; fgassert=true;}
    // and now try to control for colour clashes:
    var colclash=true;
    var cbg=colorsplit(textbg), cfg=colorsplit(textfg);
    if (cfg.r>=cbg.r+128 || cfg.r<=cbg.r-128) colclash=false;
    if (cfg.g>=cbg.g+128 || cfg.g<=cbg.g-128) colclash=false;
    if (cfg.b>=cbg.b+128 || cfg.b<=cbg.b-128) colclash=false;
    if (colclash && (!bgassert || !fgassert))
    { var bglight = (cbg.r+cbg.g+cbg.b>=128*3); var bgopp=bglight?'black':'white';
      var fglight = (cfg.r+cfg.g+cfg.b>=128*3); var fgopp=fglight?'black':'white';
      if (!fgassert) textfg=bgopp;
      else textbg=fgopp;
    }
  }
  else if (e && e.getAttribute("ip")=="*")
  { text = "";
  }
  if (typeof bgassert=='string') {bgassert = (bgassert=='true');}
  if (typeof fgassert=='string') {fgassert = (fgassert=='true');}
  //

  if (cmd=="edit" || (cmd=="edit0" && editable_selected_type=='wysiwyg' && !editable_ctrl))
  { // do a little jiggle so the window has no history
    var p=iframe.parentNode, n=iframe.nextSibling; p.removeChild(iframe);
    var if2 = iframe.cloneNode(true); p.insertBefore(if2,n);
    iframe=if2;
    editable_furniture_mode='edit'; ShowFurniture();
    iframe.contentWindow.document.designMode="On";
    iframe.contentWindow.document.open();
    iframe.contentWindow.document.write(text);
    iframe.contentWindow.document.close();
    command('styleWithCSS','false');
    iframe.contentWindow.document.body.style.backgroundColor=textbg;
    iframe.contentWindow.document.body.style.color=textfg;
    iframe.setAttribute("editable_bgassert",bgassert);
    iframe.setAttribute("editable_fgassert",fgassert);
  }

  else if (cmd=="html")
  { textarea.value = text;
    textarea.style.backgroundColor=textbg;
    textarea.style.color=textfg;
    textarea.setAttribute("editable_bgassert",bgassert);
    textarea.setAttribute("editable_fgassert",fgassert);
    editable_furniture_mode='raw'; ShowFurniture();
    textarea.scrollIntoView(); textarea.focus();
  }

  else if (cmd=="edit0" && editable_selected_type=='public')
  { text = text.replace(/\r\n/g,'\n').replace(/\r/g,'\n').replace(/<br\/?>/gi,'\n').replace(/&lt;/gi,'<').replace(/&gt;/gi,'>').replace(/&amp;/gi,'&').replace(/&nbsp;/gi,' ').replace(/\n \n/g,'\n\n');
    textarea.value = text;
    textarea.style.backgroundColor=textbg;
    textarea.style.color=textfg;
    textarea.setAttribute("editable_bgassert",'false');
    textarea.setAttribute("editable_fgassert",'false');
    editable_furniture_mode='raw'; ShowFurniture();
    textarea.scrollIntoView(); textarea.focus();
  }


  else if (cmd=="edit0" && (editable_selected_type=='code' || editable_selected_type=='markup' || editable_ctrl))
  { if (editable_xmlbusy) {alert("busy"); return;}
    var innerouter="inner";
    if (editable_selected_type=='wysiwyg' && editable_ctrl) editable_selected_type='markup';
    if (editable_selected_node.tagName=='BODY')
    { editable_selected_xpath='/'; innerouter="outer";
    }
    if (editable_selected_node.tagName=='TABLE') innerouter="outer";

    editable_furniture_mode='ajax'; ShowFurniture();
    editable_xmlbusy = document.getElementById("editable.disable");
    editable_xmlbusy.innerHTML="loading...";
    var req = editable_path+'editable.php?get&innerouter='+innerouter+'&path='+encodeURIComponent(editable_curpath)+'&file='+encodeURIComponent(urlsplit(location.href).file)+'&xpath='+encodeURIComponent(editable_selected_xpath)+'&random='+Math.floor(Math.random()*99999);
    editable_xmlhttp.open('get',req,true);
    editable_xmlhttp.onreadystatechange = function()
    { if (editable_xmlhttp.readyState!=4) return;
      editable_xmlbusy=false;
      if (editable_xmlhttp.status!=200) {alert(striptags(editable_xmlhttp.responseText)); editable_furniture_mode=''; ShowFurniture(); return;}
      var t=editable_xmlhttp.responseText;
      if (editable_selected_type=='code') t=code_markdown(t);
      textarea.value = t;
      textarea.style.backgroundColor=textbg;
      textarea.style.color=textfg;
      textarea.setAttribute("editable_bgassert",bgassert);
      textarea.setAttribute("editable_fgassert",fgassert);
      editable_furniture_mode='raw'; ShowFurniture();
    }
    editable_xmlhttp.send(null);
  }

  else if (cmd=='log')
  { if (editable_xmlbusy) {alert("busy"); return;}
    function logcc(ver)
    { if (!ver) return;
      if (editable_xmlbusy) {alert("busy"); return;}
      var oldmode=editable_furniture_mode; // was it 'edit' or 'raw'?
      editable_furniture_mode='ajax'; ShowFurniture();
      editable_xmlbusy = document.getElementById("editable.disable");
      editable_xmlbusy.innerHTML="loading...";
      var innerouter="inner";
      if (editable_selected_xpath=='/') innerouter="outer";
      if (editable_selected_node.tagName=='TABLE') innerouter="outer";

      var req = editable_path+'editable.php?get&innerouter='+innerouter+'&path='+encodeURIComponent(editable_curpath)+'&file='+encodeURIComponent(urlsplit(location.href).file)+'&xpath='+encodeURIComponent(editable_selected_xpath)+'&ver='+encodeURIComponent(ver)+'&random='+Math.floor(Math.random()*99999);
      editable_xmlhttp.open('get',req,true);
      editable_xmlhttp.onreadystatechange = function()
      { if (editable_xmlhttp.readyState!=4) return;
        editable_xmlbusy=false;
        editable_furniture_mode=oldmode; ShowFurniture();
        if (editable_xmlhttp.status!=200) {alert(striptags(editable_xmlhttp.responseText)); return;}
        if (oldmode=='raw' && editable_selected_type=='code') textarea.value = code_markdown(editable_xmlhttp.responseText);
        else if (oldmode=='raw')
        { textarea.value = editable_xmlhttp.responseText;
        }
        else if (oldmode=='edit')
        { // the jiggle to make iframe have no history
          var if2 = iframe.cloneNode(true);
          iframe.parentNode.insertBefore(if2,iframe);
          iframe.parentNode.removeChild(iframe);
          iframe=if2;
          iframe.contentWindow.document.designMode="On";
          iframe.contentWindow.document.open();
          iframe.contentWindow.document.write(editable_xmlhttp.responseText);
          iframe.contentWindow.document.close();
          command('styleWithCSS','false');
        }
      }
      editable_xmlhttp.send(null);
    }
    do_dialog('log',logcc);
  }


  else if (cmd=="submit" && editable_selected_type!='public')
  { if (editable_xmlbusy) {alert("busy"); return;}
    var oldmode = editable_furniture_mode;
    var oldtext = e.innerHTML, oldbg=e.style.backgroundColor, oldfg=e.style.color;
    var oldc=null; if (e.tagName=="BODY")
    { oldc=document.getElementById("editable_container");
      document.body.removeChild(oldc);
    }

    if (editable_selected_type=='code') text=code_markup(text);
    else if (editable_selected_type=='wysiwyg') text=htmltidy(text);
    if (editable_selected_node.tagName=='TABLE') editable_selected_node=SetOuterHTML(e,text);
    else editable_selected_node=SetInnerHTML(editable_selected_node,text); // IE doesn't respect newlines when we set innerHTML normally
    e=editable_selected_node;
    if (bgassert) e.style.backgroundColor=textbg;
    if (fgassert) e.style.color=textfg;
    var outerHTML = GetOuterHTML(e);
    outerHTML = ampersandise(outerHTML);
    if (editable_selected_xpath=='/') outerHTML=text;
   
    if (oldc) {document.body.appendChild(oldc);}

    editable_furniture_mode='ajax'; ShowFurniture();
    editable_xmlbusy = document.getElementById("editable.disable");
    editable_xmlbusy.innerHTML="saving...";
    var req = editable_path+'editable.php?set&innerouter=outer&path='+encodeURIComponent(editable_curpath)+'&file='+encodeURIComponent(urlsplit(location.href).file)+'&xpath='+encodeURIComponent(editable_selected_xpath);
    editable_xmlhttp.open('post',req,true);
    editable_xmlhttp.onreadystatechange = function()
    { if (editable_xmlhttp.readyState!=4) return;
      editable_xmlbusy=false;
      if (editable_xmlhttp.status!=200 || editable_xmlhttp.responseText!='editable:set')
      { e.innerHTML=oldtext; e.style.backgroundColor=oldbg;e.style.color=oldfg;
        alert(striptags(editable_xmlhttp.responseText)); 
        editable_furniture_mode=oldmode; ShowFurniture(); return;
      }
      editable_furniture_mode=''; ShowFurniture();
      if (editable_selected_xpath=='/') location.reload();
    }
    editable_xmlhttp.setRequestHeader('Content-Type','application/x-www-form-urlencoded; charset=UTF-8');
    editable_xmlhttp.send('value='+encodeURIComponent(outerHTML));
  }

  else if (cmd=="submit" && editable_selected_type=="public")
  { if (editable_xmlbusy) {alert("busy"); return;}
    var oldmode = editable_furniture_mode;
    var oldtext = e.innerHTML; e.innerHTML=text;    
    editable_furniture_mode='ajax'; ShowFurniture();
    editable_xmlbusy = document.getElementById("editable.disable");
    editable_xmlbusy.innerHTML="saving...";
    var req = editable_path+'publiceditable.php?pubset&innerouter=inner&path='+encodeURIComponent(editable_curpath)+'&file='+encodeURIComponent(urlsplit(location.href).file)+'&xpath='+encodeURIComponent(editable_selected_xpath);
    editable_xmlhttp.open('post',req,true);
    editable_xmlhttp.onreadystatechange = function()
    { if (editable_xmlhttp.readyState!=4) return;
      editable_xmlbusy=false;
      if (editable_xmlhttp.status!=200 || editable_xmlhttp.responseText!='editable:set')
      { e.innerHTML=oldtext;
        alert(striptags(editable_xmlhttp.responseText)); 
        editable_furniture_mode=oldmode; ShowFurniture(); return;
      }
      editable_furniture_mode=''; ShowFurniture();
      if (editable_selected_node.getAttribute("ip")=="*") location.reload();
    }
    editable_xmlhttp.setRequestHeader('Content-Type','application/x-www-form-urlencoded; charset=UTF-8');
    editable_xmlhttp.send('value='+encodeURIComponent(text));
  }

  else if (cmd=="cancel")
  { editable_furniture_mode=''; ShowFurniture();
  }

  else if (cmd=="meta")
  { //
    function metacc(r)
    { if (!r) return;
      editable_furniture_mode='ajax';
      ShowFurniture();
      editable_xmlbusy = document.getElementById("editable.disable");
      editable_xmlbusy.innerHTML="updating...";
      var req = editable_path+'editable.php?get&innerouter=inner&path='+encodeURIComponent(editable_curpath)+'&file='+encodeURIComponent(urlsplit(location.href).file)+'&xpath=/head[0]';
      editable_xmlhttp.open('get',req,true);
      editable_xmlhttp.onreadystatechange = function()
      { if (editable_xmlhttp.readyState!=4) return;
        if (editable_xmlhttp.status!=200) {alert(striptags(editable_xmlhttp.responseText)); editable_xmlbusy=false; editable_furniture_mode=''; ShowFurniture(); do_dialog('meta',metacc); return;}
        var oldhead = editable_xmlhttp.responseText, head=oldhead;
        //
        head = head.replace(/<meta[^>]*?name=['"]?description[^>]*>\n?/i,'');
        head = head.replace(/<meta[^>]*?name=['"]?keywords[^>]*>\n?/i,'');
        head = head.replace(/<title>[^>]*<\/title>\n?/i,'<title>'+r.title+'</title>\n<meta name="description" content="'+r.description+'"/>\n<meta name="keywords" content="'+r.keywords+'"/>\n');
        //
        editable_xmlbusy.innerHTML="saving...";
        // to stop firefox reusing the same onreadystatechange:
        editable_xmlhttp.abort();
        try {editable_xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");}
        catch(e) {editable_xmlhttp = new XMLHttpRequest();}
        var req = editable_path+'editable.php?set&innerouter=inner&path='+encodeURIComponent(editable_curpath)+'&file='+encodeURIComponent(urlsplit(location.href).file)+'&xpath=/head[0]';
        editable_xmlhttp.open('post',req,true);
        editable_xmlhttp.onreadystatechange = function()
        { editable_xmlbusy=false;
          if (editable_xmlhttp.readyState!=4) return;
          if (editable_xmlhttp.status!=200 || editable_xmlhttp.responseText!='editable:set')
          { alert(editable_xmlhttp.responseText); 
            editable_xmlbusy=false; do_dialog('meta',metacc); return;
          }
          editable_furniture_mode='';
          SetMeta(r); ShowFurniture();
        } // end onreadystatechange for SET
        editable_xmlhttp.setRequestHeader('Content-Type','application/x-www-form-urlencoded; charset=UTF-8');
        var text = head;
        editable_xmlhttp.send('value='+encodeURIComponent(text));
      } // end onreadystatechange for GET
      editable_xmlhttp.send(null);
    } // end function metacc

    var r = GetMeta();
    document.getElementById("editable.dialog.meta.title").value=r.title;
    document.getElementById("editable.dialog.meta.title").haschanged=false;
    document.getElementById("editable.dialog.meta.description").value=r.description;
    document.getElementById("editable.dialog.meta.description").haschanged=false;
    document.getElementById("editable.dialog.meta.keywords").value=r.keywords;
    document.getElementById("editable.dialog.meta.keywords").haschanged=false;
    editable_selected_node=null; ShowFurniture();
    do_dialog('meta',metacc);
  }


  else alert("control: cmd="+cmd)
}

function ShowFurniture()
{ // mode is "", "raw", "edit", "ajax"
  var mode = editable_furniture_mode;
  var wh=window.innerHeight?window.innerHeight:document.documentElement.clientHeight;
  var ww=window.innerWidth?window.innerWidth:document.documentElement.clientWidth;
  var tb = document.getElementById("editable.toolbar");
  var d = document.getElementById("editable.disable");
  var e = editable_selected_node, be = e?GetBounds(e):{left:0,top:0,right:ww,bottom:wh,width:ww,height:wh};
  var textarea = document.getElementById("editable.textarea");
  var iframe = document.getElementById("editable.iframe");
  var root = document.getElementsByTagName("HTML")[0];
    
  // Showing or hiding the toolbar
  // We might need to move the body down so it's not hidden under the toolbar
  if (typeof tb.editable_toolbar_margin=='string')
  { root.style.marginTop=tb.editable_toolbar_margin;
    tb.editable_toolbar_margin=false;
    if (e) be=GetBounds(e);
  }
  //
  if (mode!="edit") tb.style.display='none';
  else
  { tb.style.display = ''; var bt = GetBounds(tb);
    if (be.top<bt.height) {tb.editable_toolbar_margin=root.style.marginTop; root.style.marginTop=bt.height+"px"; be=GetBounds(e);}
  }
  

  // Showing or hiding the dialog
  var dialog0 = document.getElementById("editable.dialog.back0");
  var dialog = document.getElementById("editable.dialog.back");
  if (!editable_dialog) {dialog0.style.display='none'; dialog.style.display='none';}
  else
  { dialog0.style.display='';
    var col=GetBackgroundColor(e); dialog0.style.backgroundColor=colorjoin(col);
    dialog.style.display='';
    var bt = GetBounds(tb);
    var w=Math.floor(ww*0.7); if (w<500) w=500; if (w>ww-50) w=ww-50; if (w<200) w=200;
    var h=700; if (h+bt.height+50>wh) h=wh-bt.height-50;
    var x=Math.floor((ww-w)/2), y=bt.height;
    dialog.style.top=y+'px'; dialog.style.left=x+'px'; dialog.style.width=w+'px'; dialog.style.height=h+'px';
    //
    var color = document.getElementById("editable.dialog.color");
    var table = document.getElementById("editable.dialog.table");
    var meta = document.getElementById("editable.dialog.meta");
    var log = document.getElementById("editable.dialog.log");
    var link = document.getElementById("editable.dialog.link");
    var image = document.getElementById("editable.dialog.image");
    var cancel = document.getElementById("editable.dialog.cancel");
    var waiting = document.getElementById("editable.dialog.waiting");
    color.style.display = (editable_dialog=='color')?'':'none';
    image.style.display = (editable_dialog=='image')?'':'none';
    link.style.display = (editable_dialog=='link')?'':'none';
    log.style.display = (editable_dialog=='log')?'':'none';
    meta.style.display = (editable_dialog=='meta')?'':'none';
    table.style.display = (editable_dialog=='table')?'':'none';
    cancel.style.display = (editable_dialog!='waiting')?'':'none';
    waiting.style.display = (editable_dialog=='waiting')?'':'none';
  }
    
  // Greying out the selected element
  if (mode=="") d.style.display='none';
  else
  { offb=GetBounds(d.parentNode); // ??? I don't know why this works
    d.style.display='';
    d.style.left=(be.left-offb.left)+"px";
    d.style.top=(be.top-offb.top)+"px";
    d.style.width=be.width+"px"; d.style.height=be.height+"px";
    if (mode=="ajax")
    { d.style.opacity='0.8'; d.style.filter='alpha(opacity=80)';
      d.style.backgroundColor='rgb(128,128,128)';
      d.style.lineHeight=(be.height<300?be.height:300)+"px";
    }
    else
    { d.style.opacity=''; d.style.filter='';
      d.style.backgroundColor=colorjoin(GetBackgroundColor(e));
      d.innerHTML="";
    }
  }

  // showing the iframe or textarea
  if (mode!="raw") textarea.style.display='none';
  if (mode!="edit") iframe.style.display='none';
  var x=be.left, y=be.top, w=be.width, h=be.height, edit=null;
  if (mode=="edit")
  { edit=iframe;
    var bt = GetBounds(tb);
    if (h<200) h=200;
    if (w<200) w=200; if (w>ww-x) w=ww-x; if (w<100) w=100;
    if (x+w>ww-20) x=ww-w-20;
  }
  else if (mode=="raw")
  { edit=textarea;
    if (h<200) h=200;
    if (w<700) w=700; if (w>ww-x-25) w=ww-x-25; if (w<100) w=100;
    if (editable_selected_xpath=='/') {be.left=0; be.top=0; h=wh; w=ww;}
  }  
  if (edit)
  { var offb = GetBounds(edit.parentNode); // ??? I don't know why this works
    edit.style.display=''; edit.style.left=(be.left-offb.left)+"px"; edit.style.top=(be.top-offb.top)+"px";
    edit.style.width=w+"px"; edit.style.height=h+"px";
    be=GetBounds(edit);
  }
    

  // Moving and showing the meta control
  //
  var we = document.getElementById("editable.meta.controls");
  var offb = GetBounds(we.parentNode);
  we.style.top = -offb.top+"px"; we.style.left = -offb.left+"px";
  we.style.display = (mode=='' && !editable_dialog) ? '' : 'none';


  // Moving and showing the edit/submit/cancel controls
  //
  document.getElementById("editable_controls").style.display = (editable_selected_node && !editable_dialog)?'':'none';
  document.getElementById("editable_controls_edit0").style.display = (mode=="")?'':'none';
  document.getElementById("editable_controls_edit0").innerHTML = (editable_selected_type=='wysiwyg' && !editable_ctrl)?'&dagger;':'&Dagger;';
  document.getElementById("editable_controls_edit").style.display = (mode=="raw" && editable_selected_type=='wysiwyg')?'':'none';
  document.getElementById("editable_controls_raw").style.display = (mode=="edit")?'':'none';
  document.getElementById("editable_controls_log").style.display = ((mode=="edit" || mode=="raw") && editable_selected_type!="public")?'':'none';
  document.getElementById("editable_controls_submit").style.display = (mode=="edit"||mode=="raw")?'':'none';
  document.getElementById("editable_controls_cancel").style.display = (mode=="edit"||mode=="raw")?'':'none';


  ScrollFurniture();
}

function ScrollFurniture()
{ var mode=editable_furniture_mode;
  var e=null;
  if (mode=='edit') e=document.getElementById('editable.iframe');
  else if (mode=='raw') e=document.getElementById('editable.textarea');
  else e=editable_selected_node;
  if (!e) return;
  var c = document.getElementById("editable_controls");
  if (c.style.display=='none') return;
  c.style.top='-100px'; c.style.left='0px';
  var be = GetBounds(e,true), bc = GetBounds(c);
  var wx = document.documentElement?document.documentElement.scrollLeft:document.body.scrollLeft;
  var wy = document.documentElement?document.documentElement.scrollTop:document.body.scrollTop;
  var root = document.getElementsByTagName("HTML")[0]; if (root.style.marginTop) wy-=parseInt(root.style.marginTop);
  var ww=window.innerWidth?window.innerWidth:document.documentElement.clientWidth;
  var wh=window.innerHeight?window.innerHeight:document.documentElement.clientHeight;
  var tb = document.getElementById("editable.toolbar"), bt=GetBounds(tb);
  if (tb.style.display!='none') {wy+=bt.height; wh-=bt.height;}
  var offb=GetBounds(c.parentNode);
  // initial attempted position:
  var x=be.right-bc.width;
  var y=be.top;
  // force it onscreen
  if (x-wx+bc.width >ww-18) x=ww-18+wx-bc.width;  if (x<wx) x=wx; 
  if (y-wy+bc.height>wh) y=wh+wy-bc.height; if (y<wy) y=wy;
  // force it into its container
  if (x<be.left) x=be.left; if (x+bc.width >be.right)  x=be.right -bc.width;
  if (y<be.top)  y=be.top;  if (y+bc.height>be.bottom) y=be.bottom-bc.height;
  //
  c.style.top=(y-offb.top)+'px'; c.style.left=(x-offb.left)+'px';
}


function GetEditorSelection(c)
{ // about ranges: http://www.wrox.com/WileyCDA/Section/id-292301.html
  // IE implementation: http://mozile.mozdev.org/0.8/doc/jsdoc/overview-summary-InternetExplorerRange.js.html
  var r;
  if (!c) c = document.getElementById("editable.iframe").contentWindow;
  if (c.document.selection && c.document.selection.createRange) r=c.document.selection.createRange();
  else if (c.getSelection) r=c.getSelection().getRangeAt(0);
  else if (c.document.getSelection) r=c.document.getSelection().getRangeAt(0);
  else return null;
  if (r.length==1 && r[0]==null) return null;
  // startNode:
  if (r.startContainer)
  { var s = r.startContainer.nodeName;
    if (s=="HTML" || s=="HEAD" || s=="") return null;
    var a=r.startContainer; if (a.nodeType!=3) a=a.childNodes[r.startOffset];
    r.startNode = a;
  }
  else 
  { var r2 = r.duplicate(); r2.collapse(true); r2.move('Character', 1); r2.move('Character', -1);
    r2.pasteHTML('<span id="_temp_range_placeholder"></span>');
    var p = c.document.getElementById('_temp_range_placeholder');
    if (!p) return null;
    var p2=p; if (p2.parentNode.childNodes.length==1) p2=p2.parentNode;
    r.startNode = p2.nextSibling;
    if ((!r.startNode || r.startNode.nodeType==3) && p2.previousSibling) r.startNode = p2.previousSibling; // in case cursor was at the end of a block
    if (!r.startNode) {alert("failed to find start of selection"); return null;}
    p.parentNode.removeChild(p);
  }
  // endNode:
  if (r.endContainer)
  { var b=r.endContainer; if (b.nodeType!=3) b=b.childNodes[r.endOffset];
    r.endNode = b;
  }
  else 
  { var r2 = r.duplicate(); r2.collapse(false);
    r2.pasteHTML('<span id="_temp_range_placeholder"></span>');
    var p = c.document.getElementById('_temp_range_placeholder');
    r.endNode = p.previousSibling;
    p.parentNode.removeChild(p); 
  }
  // collapsed:
  if (typeof r.collapsed=='undefined')
  { r.collapsed = (r.boundingWidth==0);
  }
  // commonAncestorNode:
  common: for (var a=r.startNode; a!=null; a=a.parentNode)
  { s+="A:"+a.tagName+" b:";
    for (b=r.endNode; b!=null; b=b.parentNode)
    { s+=b.tagName+",";
      if (IsSameNode(a,b)) {r.commonAncestorNode=b; break common;}
    }
  }
  // pasteHTML:
  if (!r.pasteHTML) r.pasteHTML=function(s)
  { var t = c.document.createElement('div');
    t.innerHTML=s;
    var htmlnodes = [];
    for (var i=0; i<t.childNodes.length; i++) htmlnodes.push(t.childNodes[i]);
    // htmlnodes is a copy. That's because the actual object t.childNodes
    // will get mutated whenever we add an element of it elsewhere in
    // the tree. And that got too hairy.

    var sel = c.getSelection(); sel.removeAllRanges();
    this.deleteContents();
    var container=this.startContainer, pos=this.startOffset;
    var r2=c.document.createRange(), afterNode;
    if (container.nodeType==3)
    { var textNode=container; container=textNode.parentNode;
      var text=textNode.nodeValue, textBefore=text.substr(0,pos), textAfter=text.substr(pos);
      var beforeNode=c.document.createTextNode(textBefore), afterNode=c.document.createTextNode(textAfter);
      container.insertBefore(afterNode, textNode);
      container.insertBefore(beforeNode, afterNode);
      for (var i=0; i<htmlnodes.length; i++) container.insertBefore(htmlnodes[i], afterNode);
      container.removeChild(textNode);
    }
    else
    { afterNode = container.childNodes[pos];
      for (var i=0; i<htmlnodes.length; i++) container.insertBefore(htmlnodes[i],afterNode);
    }
    r2.setEnd(afterNode,0); r2.setStart(afterNode,0);
    sel.addRange(r2);
  }
  // htmlText:
  if (typeof r.htmlText=='undefined') 
  { var c2 = r.cloneContents();
    var c3 = c2.ownerDocument.createElement('div');
    c3.appendChild(c2);
    r.htmlText=c3.innerHTML;
  }
  //
  return r;
}

function do_dialog(mode,cc)
{ dialog_callback=cc;

  if (mode=='color')
  { editable_dialog='color';
    ShowFurniture();
  }

  else if (mode=='table')
  { editable_dialog='table';
    ShowFurniture();
    var m = /(\d*),(\d*),(\d*)/.exec(editable_table); if (!m) return;
    var borders=(parseInt(m[1])>0), w=parseInt(m[2]), h=parseInt(m[3]);
    document.getElementById("editable.dialog.table.w").value=w;
    document.getElementById("editable.dialog.table.h").value=h;
    document.getElementById("editable.dialog.table.borders").checked=borders;
    dialog('table','preview');
  }

  else if (mode=='meta')
  { editable_dialog='meta';
    ShowFurniture();
  }

  else if (mode=='log')
  { editable_dialog='log';
    ShowFurniture();
    var e = document.getElementById("editable.dialog.log.list");
    e.innerHTML="looking for past versions...";
    var req = editable_path+'editable.php?log&path='+encodeURIComponent(editable_curpath)+'&file='+encodeURIComponent(urlsplit(location.href).file)+'&xpath='+encodeURIComponent(editable_selected_xpath)+'&random='+Math.floor(Math.random()*9999);
    editable_xmlbusy = e;
    editable_xmlhttp.open('get',req,true);
    editable_xmlhttp.onreadystatechange = function()
    { if (editable_xmlhttp.readyState!=4) return;
      editable_xmlbusy = false;
      if (editable_xmlhttp.status!=200) {alert(striptags(editable_xmlhttp.responseText)); dialog('cancel'); return;}
      var vers=editable_xmlhttp.responseText.split("\n"), s="";
      for (var i=vers.length-1; i>=0; i--)
      { var v=vers[i].split("\t"); if (v=="") continue;
        s += '<span onmousedown="dialog(\'select\',\''+v[0]+'\');" style="color:rgb(0,5,80); text-decoration:underline; cursor:pointer;">'+htmlspecialchars(v[0])+"</span><br/>";
        if (v.length>1) s += "&nbsp; &nbsp; "+htmlspecialchars(striptags(v[1]))+"<br/>";
      }
      if (s=="") s="(There are no past versions)";
      e.innerHTML = s;
    }
    editable_xmlhttp.send(null);
  }

  else if (mode=='link')
  { editable_dialog='link';
    ShowFurniture();
    document.getElementById("editable.dialog.link.external").value = editable_link;
    link_refresh();
  }

  else if (mode=='image')
  { editable_dialog='image';
    ShowFurniture();
    image_refresh();
  }

  else alert(mode);
}


function image_refresh(d)
{ // the variable "editable_remotedir" says where to browse to
  if (d) editable_remotedir=d;
  if (!editable_remotedir.match(/^\//) || !editable_remotedir.match(/\/$/)) editable_remotedir=editable_curpath;
  document.getElementById("editable.dialog.image.form").action=editable_path+'editable.php?upload&path='+encodeURIComponent(editable_remotedir);

  var e = document.getElementById("editable.dialog.image.list");
  e.innerHTML="looking for pictures already uploaded...";
  var req = editable_path+"editable.php?dir&path="+encodeURIComponent(editable_remotedir)+"&random="+Math.floor(Math.random()*99999);
  editable_xmlbusy = e;
  editable_xmlhttp.open('get',req,true);
  editable_xmlhttp.onreadystatechange = function()
  { if (editable_xmlhttp.readyState!=4) return;
    editable_xmlbusy = false;
    if (editable_xmlhttp.status!=200) {alert(striptags(editable_xmlhttp.responseText)); dialog('cancel'); return;}
    var files=editable_xmlhttp.responseText.split("\n"), s="", dirs=[];
    for (var i=0; i<files.length; i++)
    { var m = /dir:(\S*)/.exec(files[i]); if (m) {dirs.push(m[1]); continue;}
      var m = /fnsize:(\d*),(\d*),([^\r\n]*)/.exec(files[i]); if (!m) continue;
      var fn=m[3], x=parseInt(m[1]), y=parseInt(m[2]), tx=x, ty=y;
      if (tx>ty) {ty=ty/tx*128; tx=128;} else {tx=tx/ty*128; ty=128;}
      tx=Math.floor(tx); ty=Math.floor(ty);
      s += '<table cellspacing="0" cellborder="0" style="display:inline; width:128px; height:150px; cursor:pointer;" onmousedown="dialog(\'select\',\'fnsize:'+x+','+y+','+escapestring(editable_remotedir+fn)+'\');">'+
           '<tr><td style="width:128px; height:128px; overflow:hidden; text-align:center; vertical-align:bottom;">'+
           '<img src="'+encodeURI(editable_remotedir+fn)+'" width="'+tx+'px" height="'+ty+'px"/></td></tr>'+
           '<tr><td style="font-size:8pt; font-family:Arial,sans-serif; vertical-align:middle; text-align:center; overflow:hidden; color:rgb(0,5,80); text-decoration:underline;">'+htmlspecialchars(fn)+
           '</td></tr></table> ';
    }
    
    // and now for the directories
    var d=editable_remotedir, ds="&nbsp;", dacc="";
    while (m = d.match(/^([^\/]*\/)/))
    { dacc+=m[1]; var fn=m[1];
      ds+=' <span style="text-decoration:underline; cursor:pointer;" onclick="image_refresh(\''+escapestring(dacc)+'\');">'+htmlspecialchars(fn)+'</span>';
      d=d.substr(m[1].length);
    }
    ds+="<br/>"; if (dirs.length>0) ds+="&nbsp;";
    for (var i=0; i<dirs.length; i++)
    { if (dirs[i]=='.' || dirs[i]=='..') continue;
      dacc=editable_remotedir+dirs[i]+"/"; fn=dirs[i];
      ds+=' <span style="text-decoration:underline; cursor:pointer;" onclick="image_refresh(\''+escapestring(dacc)+'\');">'+htmlspecialchars(fn)+'</span>';
    }
    ds='<div style="font-size:8pt; font-family:Arial,sans-serif; color:rgb(0,5,80);">'+ds+'</div>';
    
    e.innerHTML = ds+s;
  }
  editable_xmlhttp.send(null);
}


function link_refresh(d)
{ // the variable "editable_remotedir" says where to browse to
  if (d) editable_remotedir=d;
  if (!editable_remotedir.match(/^\//) || !editable_remotedir.match(/\/$/)) editable_remotedir=editable_curpath;

  var e = document.getElementById("editable.dialog.link.list");
  e.innerHTML="looking for existing links...";
  var req = editable_path+"editable.php?dir&path="+encodeURIComponent(editable_remotedir)+"&random="+Math.floor(Math.random()*99999);
  editable_xmlbusy = e;
  editable_xmlhttp.open('get',req,true);
  editable_xmlhttp.onreadystatechange = function()
  { if (editable_xmlhttp.readyState!=4) return;
    editable_xmlbusy = false;
    if (editable_xmlhttp.status!=200) {alert(striptags(editable_xmlhttp.responseText)); dialog('cancel'); return;}
    var files=editable_xmlhttp.responseText.split("\n"), s="", dirs=[];
    for (var i=0; i<files.length; i++)
    { var m = /dir:(\S*)/.exec(files[i]); if (m) {dirs.push(m[1]); continue;}
      var fn; m = /fnsize:(\d*),(\d*),([^\r\n]*)/.exec(files[i]);
      if (m) fn=m[3];
      else {m = /fn:([^\r\n]*)/.exec(files[i]); if (m) fn=m[1]; else continue;}
      s += '<span style="cursor:pointer; color:rgb(0,5,80); text-decoration:underline;" onmousedown="dialog(\'select\',\''+escapestring(editable_remotedir+fn)+'\');">'+htmlspecialchars(fn)+'</span>';
      s += '<span style="color:rgb(220,40,10); font-weight:bold; font-family:Courier New; font-size:small; cursor:pointer;" onmousedown="link_delete(\''+escapestring(editable_remotedir+fn)+'\');">&times;</span> &nbsp;';
    }

    // and now for the directories
    var d=editable_remotedir, ds="&nbsp;", dacc="";
    while (m = d.match(/^([^\/]*\/)/))
    { dacc+=m[1]; var fn=m[1];
      ds+=' <span style="text-decoration:underline; cursor:pointer;" onclick="link_refresh(\''+escapestring(dacc)+'\');">'+htmlspecialchars(fn)+'</span>';
      d=d.substr(m[1].length);
    }
    ds+="<br/>"; if (dirs.length>0) ds+="&nbsp;";
    for (var i=0; i<dirs.length; i++)
    { if (dirs[i]=='.' || dirs[i]=='..') continue;
      dacc=editable_remotedir+dirs[i]+"/"; fn=dirs[i];
      ds+=' <span style="text-decoration:underline; cursor:pointer;" onclick="link_refresh(\''+escapestring(dacc)+'\');">'+htmlspecialchars(fn)+'</span>';
    }
    ds='<div style="font-size:8pt; font-family:Arial,sans-serif; color:rgb(0,5,80);">'+ds+'</div>';
    
    e.innerHTML = ds+s;
  }
  editable_xmlhttp.send(null);
}

function link_delete(fn)
{ var r = confirm("Do you want to delete '"+fn+"' ?");
  if (!r) return;
  var e = document.getElementById("editable.dialog.link.list");
  e.innerHTML="deleting...";
  var req = editable_path+"editable.php?delete&path="+encodeURIComponent(urlsplit(fn).path)+"&file="+encodeURIComponent(urlsplit(fn).file)+"&random="+Math.floor(Math.random()*99999);
  editable_xmlbusy = e;
  editable_xmlhttp.open('get',req,true);
  editable_xmlhttp.onreadystatechange = function()
  { if (editable_xmlhttp.readyState!=4) return;
    editable_xmlbusy = false;
    if (editable_xmlhttp.status!=200) {alert(striptags(editable_xmlhttp.responseText)); link_refresh(); return;}
    link_refresh();
  }
  editable_xmlhttp.send(null);
}



function dialog(cmd,arg)
{ if (cmd=="cancel")
  { if (editable_dialog=="waiting") return;
    editable_dialog=false;
    ShowFurniture();
    editable_xmlhttp.abort(); editable_xmlbusy=false;
    if (dialog_callback) dialog_callback();
    dialog_callback=null;
  }

  else if (cmd=="select")
  { editable_dialog=false;
    ShowFurniture();
    editable_xmlhttp.abort(); editable_xmlbusy=false;
    if (dialog_callback) dialog_callback(arg);
    dialog_callback=null;
  }

  else if (cmd=="table")
  { var e = document.getElementById("editable.dialog.table.preview");
    e.innerHTML = "";
    var m = /(\d*)/.exec(document.getElementById("editable.dialog.table.w").value);
    if (!m) return; var w=parseInt(m[1]);
    m = /(\d*)/.exec(document.getElementById("editable.dialog.table.h").value);
    if (!m) return; var h=parseInt(m[1]);
    var b = document.getElementById("editable.dialog.table.borders").checked;
    if (w>20 || h>20) return;
    e.innerHTML = buildtable(w,h,b);
    if (arg=="submit") dialog("select",(b?'1':'0')+","+w+","+h);
  }

  else if (cmd=="create_link")
  { if (!arg || arg.length!=2 || arg[0].length==0) {alert("Type a page name"); return;}
    editable_xmlhttp.abort(); editable_xmlbusy=false;
    var name=arg[0].replace(/.html?$/,'');
    var fn=arg[0]; if (!/\.htm(l)?$/.exec(fn)) fn+=".html";
    var disp=arg[1]; // "copy" or "blank" or "comments"
    editable_dialog='waiting'; ShowFurniture();
    var srcfn = location.href;
    if (disp=="blank" || disp=="comments") srcfn=editable_path+"blank.html";

    editable_xmlbusy=document.getElementById("editable.dialog.waiting");
    editable_xmlbusy.innerHTML="generating...";
    editable_xmlhttp.open('get',srcfn,true);
    editable_xmlhttp.onreadystatechange = function()
    { if (editable_xmlhttp.readyState!=4) return;
      editable_xmlbusy = false;
      if (editable_xmlhttp.status!=200) {alert(striptags(editable_xmlhttp.responseText)); dialog('cancel'); return;}
      var text = editable_xmlhttp.responseText.replace(/<[Tt][Ii][Tt][Ll][Ee]>.*?<\/[Tt][Ii][Tt][Ll][Ee]>/,'<title>'+htmlspecialchars(name)+'</title>');
      if (disp=="blank" || disp=="comments")
      { text=text.replace(/<[Hh]1>.*?<\/[Hh]1>/,'<h1>'+htmlspecialchars(name)+'</h1');
        text = text.replace(/(<[Ss][Cc][Rr][Ii][Pp][Tt][^>]*?src=["'])[^"']*?editable.js(["'][^>]*>)/, '$1'+editable_path+'editable.js$2');
      }
      if (disp=="blank")
      { text = text.replace(/<div\s*ip="\*".*?<\/div>\r?\n?/g,'');
      }
      editable_xmlbusy.innerHTML="creating...";
      editable_xmlhttp.abort();
      try {editable_xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");}
      catch(e) {editable_xmlhttp = new XMLHttpRequest();}
      var req = editable_path+'editable.php?newpage&path='+encodeURIComponent(editable_remotedir)+"&file="+encodeURIComponent(fn)+"&random="+Math.floor(Math.random()*99999);
      editable_xmlhttp.open('post',req,true);
      editable_xmlhttp.onreadystatechange = function()
      { if (editable_xmlhttp.readyState!=4) return;
        editable_xmlbusy = false;
        if (editable_xmlhttp.status!=200) {alert(striptags(editable_xmlhttp.responseText)); dialog('cancel'); return;}
        dialog('select',editable_remotedir+fn);
      }
      editable_xmlhttp.setRequestHeader('Content-Type','application/x-www-form-urlencoded; charset=UTF-8');
      editable_xmlhttp.send('value='+encodeURIComponent(text));
    }
    editable_xmlhttp.send(null);
  }

  else if (cmd=="upload_start")
  { editable_dialog='waiting';
    ShowFurniture();
    editable_xmlbusy=document.getElementById("editable.dialog.waiting");
    editable_xmlbusy.innerHTML="uploading...";
  }

  else if (cmd=="upload_done")
  { editable_xmlbusy=false;
    editable_dialog=false;
    ShowFurniture();
    if (!arg.match(/^fn:/) && !arg.match(/^fnsize:/)) {alert(striptags(arg)); dialog('cancel'); return;}
    arg = arg.replace(/^(fnsize:\d*,\d*,)(.*?)\s*$/,'$1'+editable_remotedir+'$2');
    arg = arg.replace(/^(fn:)(.*?)\s*$/,'$1'+editable_remotedir+'$2');
    if (dialog_callback) dialog_callback(editable_remotedir+arg);
    dialog_callback=null;
  }
  else alert("dialog("+cmd+")");
}



function textcolor()
{ var r=GetEditorSelection();
  function cc(col)
  { if (!col) return;
    if (col=='default') col='';
    if (r && !r.collapsed) {command('forecolor',col); return;}
    var iframe = document.getElementById("editable.iframe");
    iframe.contentWindow.document.body.style.color=col;
    iframe.setAttribute("editable_fgassert",'true');
  }
  do_dialog('color',cc);
}

function backgroundcolor()
{ var r=GetEditorSelection();
  // If it's collapsed and we're in a table-cell,
  // or if it's non-collapsed and we have multiple cells selected,
  // then what we'll do is change the background colors of those cells
  var a=null,b=null,ta=null,tb=null;
  if (r)
  { a=r.startNode; while (a!=null && a.nodeName!='TD') a=a.parentNode;
    b=r.endNode;   while (b!=null && b.nodeName!='TD') b=b.parentNode;
    ta=a; while (ta!=null && ta.nodeName!='TABLE') ta=ta.parentNode;
    tb=b; while (tb!=null && tb.nodeName!='TABLE') tb=tb.parentNode;
    if (ta==null || tb==null || ta!=tb) {a=null; b=null; ta=null; tb=null;}
    if (!r.collapsed && a==b) {a=null; b=null; ta=null; tb=null;}
  }
  //
  var incell=false;
  function subbackgroundcolor(n,s,col)
  { if (n.nodeType==3) return;
    if (n==a) incell=true;
    if (incell && n.nodeName=='TD') n.style.backgroundColor=col;
    for (var i=0; i<n.childNodes.length; i++) subbackgroundcolor(n.childNodes[i], s+"."+i, col);
    if (n==b) incell=false;
  }

  //
  function cc(col)
  { if (!col) return; if (col=='default') col='';
    if (a!=null) {subbackgroundcolor(ta,"0",col); return;}
    if (r && !r.collapsed) {command('backcolor',col); return;}
    var iframe = document.getElementById("editable.iframe");
    iframe.contentWindow.document.body.style.backgroundColor=col;
    iframe.setAttribute("editable_bgassert",'true');
  }
  do_dialog('color',cc);
}
function insertlinkcc(r,link)
{ if (!link) return;
  var rlink=link; // relative link
  if (link.substr(0,1)=='/') rlink=relativize(link,editable_curpath);
  editable_link = rlink;
  // encodeURI: http://xkr.us/articles/javascript/encode-compare/
  if (r.collapsed) r.pasteHTML('<a href="'+encodeURI(rlink)+'">'+htmlspecialchars(rlink)+'</a>.');
  else command('createlink',rlink);
  //
  var dir = link.replace(/[^\/]*$/,'');
  document.cookie = "editable.path="+encodeURIComponent(dir)+"; path=/";
}


function insertlink()
{ var r=GetEditorSelection();
  if (!r) {alert("First put your cursor where the link will go, or click+drag to select some text"); return;}
  if (editable_xmlbusy) {alert("busy"); return;}
  do_dialog('link',function(link){insertlinkcc(r,link);});
}


function insertimage()
{ var r=GetEditorSelection();
  if (!r) {alert("First put your cursor where the image will go"); return;}
  if (editable_xmlbusy) {alert("busy"); return;}
  function cc(fnsize)
  { if (!fnsize) return;
    var m = /fnsize:(\d*),(\d*),(.*?)\s*$/.exec(fnsize);
    if (!m)
    { m = /fn:(.*?)\s*$/.exec(fnsize);
      if (!m) {alert("Don't know how to insert '"+fnsize+"'"); return;}
      insertlinkcc(r,m[1]); return;
    }
    var fn=m[3], x=parseInt(m[1]), y=parseInt(m[2]);
    var alt=urlsplit(fn).file.replace(/\.[a-zA-Z0-9]*$/,'');
    if (fn.length==0) {alert("Error: unexpected filename '"+fn+"'"); return;}
    var rfn=relativize(fn,editable_curpath);
    r.pasteHTML('<img src="'+encodeURI(rfn)+'" width="'+x+'" height="'+y+'" alt="'+htmlspecialchars(alt)+'"/>');
    //
    var dir = fn.replace(/[^\/]*$/,'');
    document.cookie = "editable.path="+encodeURIComponent(dir)+"; path=/";
  }
  do_dialog('image',cc);
}


function inserttable()
{ var r = GetEditorSelection();
  if (!r || !r.collapsed) {alert("First put your cursor where the table will go"); return;}
  function cc(table)
  { if (!table) return;
    var m = /(\d*),(\d*),(\d*)/.exec(table); if (!m) return;
    var borders=(parseInt(m[1])>0), w=parseInt(m[2]), h=parseInt(m[3]);
    r.pasteHTML(buildtable(w,h,borders));
    editable_table = (borders?'1':'0')+","+w+","+h;
  }
  do_dialog('table',cc);
}

function buildtable(w,h,borders)
{ var t = (borders?'&nbsp;&nbsp;':'-');
  var s = '<table border="'+(borders?'1':'0')+'">\n';
  for (var i=0; i<h; i++)
  { s+="<tr>\n";
    for (var j=0; j<w; j++) s+='<td>'+t+'</td>\n';
    s+="</tr>\n";
  }
  s+="</table>\n";
  return s;
}


function insertcode()
{ var r=GetEditorSelection(); if (!r) {alert("First put your cursor where the code will go"); return;}
  var s;
  if (r.isCollapsed) s="code";
  else s = r.htmlText.replace(/\r\n/g,'\n').replace(/\r/g,'\n');
  s = s.replace(/<br\/?>([^\n])/ig,'<br/>\n$1').replace(/<\/p>([^\n])/gi,'</p>\n$1');
  s = s.replace(/<[^>]+>/ig,'');
  s = unampersandise(s); s=s.replace(/&lt;/g,'<').replace(/&gt;/g,'>').replace(/&amp;/g,'&');
  s = code_markup(s);
  s = '<pre editable="code">'+s+'</pre>\n';
  r.pasteHTML(s);
}


// RemoveFormat. Removes all formatting from the selection.
// The normal "removeformat" command isn't enough for me. I also want to remove
// "style" and "class" and <h1> stuff.
function removeformat(runtwice)
{ var r = GetEditorSelection(); if (!r || r.collapsed) return;
  // We'll iterate over all nodes and subnodes, deleting "class" and "style" attributes
  var a=r.startNode, b=r.endNode, cc=r.commonAncestorNode
  while (a!=null && a.parentNode && !IsSameNode(a,cc) && !IsSameNode(a.parentNode,cc)) a=a.parentNode;
  while (b!=null && b.parentNode && !IsSameNode(b,cc) && !IsSameNode(b.parentNode,cc)) b=b.parentNode;
  if (!a || !b) return;

  function subremoveformat(n,s)
  { if (n.nodeType==3) return;
    if (n.removeAttribute) {n.removeAttribute("class"); n.removeAttribute("className"); n.removeAttribute("style"); }
    for (var i=0; i<n.childNodes.length; i++) subremoveformat(n.childNodes[i], s+"."+i);
  }
  var i=0; while (true)
  { subremoveformat(a,i.toString()); i++; if (IsSameNode(a,b)) break;
    a=a.nextSibling; if (a==null) break; 
  }
  // Now remove font/em/... formatting
  command("removeformat");
  // and remove h1/h2/... formatting
  command("formatblock","<p>");
  // run through again for IE. It seemed to remove even more. I don't know why.
  if (!runtwice) removeformat(true);  
}


function elog(s)
{ var e = document.getElementById("editable.log");
  if (!e)
  { e = document.createElement('div'); e.id = 'editable.log';
    e.style.position='fixed';
    var wh=window.innerHeight?window.innerHeight:document.documentElement.clientHeight;
    var ww=window.innerWidth?window.innerWidth:document.documentElement.clientWidth;
    e.style.width=(400<ww?400:ww-1)+'px';
    e.style.height=(200<wh?200:wh-1)+'px';
    e.style.bottom="0px"; e.style.right="0px";
    e.style.backgroundColor='aqua';
    e.style.fontSize='smaller';
    e.style.zIndex=(editable_zbase+400);
    e.style.overflow="auto";
    document.getElementById("editable_container").appendChild(e);
  }
  e.innerHTML=s;
}


function dump(o)
{ if (o==null) return "null";
  var s = typeof o;
  if (s=='function') return "fn";
  if (s=='string' || s=='number' || s=='undefined' || s=='boolean') return o.toString();
  s="";
  for (var i in o)
  { var v = o[i];
    if (typeof v=='function') s+=i+"=fn ";
    else if (i.substring(0,2)=="on" && o[i]==null) s+="";
    else
    { v=v+""; s+=i+"=";
      if (v.length>100) s+=v.substring(0,100)+"... ";
      else s+=v+" ";
    }
  }
  return s;
}

function command(cmd,arg)
{ // Commands:
  // http://msdn2.microsoft.com/en-us/library/ms533049.aspx
  // http://www.mozilla.org/editor/midas-spec.html
  // Range selection:
  // http://msdn2.microsoft.com/en-us/library/ms533053.aspx
  var c = document.getElementById("editable.iframe");
  var isie=true;
  if (!arg) arg=';';
  try
  { var issupported = c.contentWindow.document.queryCommandSupported(cmd);
    if (!issupported) {if (cmd!="styleWithCSS") alert(cmd+" not supported"); return;}
  } catch (e) {isie=false;}
  try
  { var isenabled = c.contentWindow.document.queryCommandEnabled(cmd);
    if (!isenabled)
    { if (cmd=="undo") return;
      else if (cmd=="redo") return;
      else if (cmd=="createlink") alert("Select some text first, and then click the Link button");
      else if (cmd=="unlink") alert("Put the cursor in a link, and then click the Unlink button");
      else alert(cmd+" not possible right now");
      return;
    }
  } catch (e) {}
  if (cmd=='backcolor' && !isie)
  { command('styleWithCSS','true');
    command('hilitecolor',arg);
    command('styleWithCSS','false');
    return;
  }
  c.contentWindow.document.execCommand(cmd,false,arg);
}


function GetBounds(e)
{ 
  // firefox: it's offsetLeft/offsetTop model is broken for tables that
  // are inline or absolutely positioned with margins. But it
  // supports getBoxObjectFor, which works better:
  if (document.getBoxObjectFor)
  { // just one problem: it gives the wrong answer for the table element of inline tables,
    // but the right answer for TBODY in all circumstances:
    if (e.tagName=='TABLE')
    { for (var i=0; i<e.childNodes.length; i++) if (e.childNodes[i].tagName=='TBODY') {e=e.childNodes[i]; break;}
    }
    var r=document.getBoxObjectFor(e);
    return {'left':r.x, 'top':r.y, 'right':r.x+r.width, 'bottom':r.y+r.height, 'width':r.width, 'height':r.height};
  }
  
  // IE: it's offsetLeft/offsetTop model is correct except in the case
  // of the last text node, But getBoundingClientRect works and is faster:
  if (e.getBoundingClientRect)
  { var r=e.getBoundingClientRect();
    var wx = document.documentElement.scrollLeft;
    var wy = document.documentElement.scrollTop;
    r.top+=wy; r.bottom+=wy; r.left+=wx; r.right+=wx;
    return {'left':r.left, 'top':r.top, 'right':r.right, 'bottom':r.bottom, 'width':r.right-r.left, 'height':r.bottom-r.top};
  }

  // Other browsers: we'll trust and pray that their offsetLeft/offsetTop model is correct
  var x=0, y=0, w=e.offsetWidth, h=e.offsetHeight;
  while (e!=null) {x+=e.offsetLeft; y+=e.offsetTop; e=e.offsetParent;}
  r= {'left':x, 'top':y, 'right':x+w, 'bottom':y+h, 'width':w, 'height':h};
}

function GetComputedStyle(node,prop)
{ try
  { if(document.defaultView) return document.defaultView.getComputedStyle(node, null).getPropertyValue(prop);
    else if (node.currentStyle)
    { for(var reExp = /-([a-z])/; reExp.test(prop); prop = prop.replace(reExp, RegExp.$1.toUpperCase()));
      return node.currentStyle[prop];
    }
  }
  catch (e) {}
  return null;
}

function GetBackgroundColor(node)
{ var r = GetComputedStyle(node,"background-color");
  if (!r) return colorsplit(document.bgColor);
  if (r=="transparent" || r=="")
  { if (node.parentNode==null) return document.bgColor;
    else return GetBackgroundColor(node.parentNode);
  }
  else return colorsplit(r);
}

function IsSameNode(a,b)
{ if (a.isSameNode) return a.isSameNode(b);
  return a==b;
}

function SetInnerHTML(e,text)
{ // because in the case of e.tagName=PRE, in IE,
  // e.innerHTML=text doesn't respect newlines in text
  if (e.tagName!='PRE') {e.innerHTML=text; return e;}
  var p=e.parentNode, e2;
  if (p) {e2=document.createElement('pre'); p.replaceChild(e2,e);}
  var c = document.createElement('div'); // for its innerHTML property
  c.appendChild(e);
  var outerHTML=c.innerHTML, innerHTML=e.innerHTML;
  var pos = outerHTML.indexOf(innerHTML);
  var s = outerHTML.substr(0,pos)+text+outerHTML.substr(pos+innerHTML.length);
  c.innerHTML=s;
  e = c.childNodes[0];
  c.removeChild(e);
  if (p) p.replaceChild(e,e2);
  return e;
}

function GetOuterHTML(e)
{ var p = e.parentNode, e2;
  if (p) {e2=e.cloneNode(false); p.replaceChild(e2,e);}
  var c = document.createElement(e.tagName=='TD'?'tr':'div'); // for its innerHTML property
  c.appendChild(e); var outerHTML=c.innerHTML; c.removeChild(e);
  if (p) p.replaceChild(e,e2);
  return outerHTML;
}

function SetOuterHTML(e,text)
{ var c = document.createElement(e.tagName=='TD'?'tr':'div');
  c.innerHTML=text; var e2=c.childNodes[0]; c.removeChild(e2);
  var p=e.parentNode;
  if (p) p.replaceChild(e2,e);
  return e2;
}


// htmlspecialchars: escapes a text so it can be used in PCDATA in the html
function htmlspecialchars(s)
{ return s.replace(/&/g,'&amp;').replace(/</g,'&lt;').replace(/>/g,'&gt;');
}

// escapestring: escapes a text so it can be used inside a javascript command
// e.g. c.innerHTML='<span onmousedown="f(\''+escapestring(s)+'\');">a</span>';
// it escapes every slash into a literal slash, and escapes quotes
function escapestring(s)
{ return s.replace(/\\/g,'\\\\').replace(/'/g,'\\\'').replace(/"/g,'\\\"');
}

// relativize: given an absolute fn "/a/b/c/d.gif" and a path "/a/b/e/"
// it returns the relative path "../c/d.gif"
function relativize(fn,path)
{ var lcp; // last common pos
  for (lcp=0; lcp<fn.length && lcp<path.length; lcp++) if (fn[lcp]!=path[lcp]) break;
  // nb. lcp will point to a / now
  var ups = path.substr(lcp).replace(/[^\/]*\//g,'../');
  return ups+fn.substr(lcp);
}

function striptags(html)
{ return html.replace(/<[^>]+>/ig,' ');
}

function trim(s)
{ while (s.substring(0,1)==' ') s=s.substring(1,s.length);
  while (s.substring(s.length-1)==' ') s=s.substring(0,s.length-1);
  return s;
}

function urlsplit(url)
{ var m = /((http|file):\/\/[^\/]*)?([^\?#]*\/)?([^\?\/#]*)(#[^\?]*)?(\?.*)?/i.exec(url);
  if (!m) return null; else return {'url':url, 'site':m[1]?m[1]:'', 'path':m[3]?m[3]:'', 'file':m[4]?m[4]:'', 'section':m[5]?m[5]:'', 'query':m[6]?m[6]:''};
}


function colorsplit(s)
{ if (s.charAt(0) == '#') s = s.substr(1,6);
  s = s.replace(/ /g,'').toLowerCase();
  s = s.toLowerCase();
  var simple_colors = {aliceblue:'f0f8ff', antiquewhite:'faebd7', aqua:'00ffff', aquamarine:'7fffd4',
        azure:'f0ffff', beige:'f5f5dc', bisque:'ffe4c4', black:'000000', blanchedalmond:'ffebcd',
        blue:'0000ff', blueviolet:'8a2be2', brown:'a52a2a', burlywood:'deb887', cadetblue:'5f9ea0',
        chartreuse:'7fff00', chocolate:'d2691e', coral:'ff7f50', cornflowerblue:'3295ed', cornsilk:'fff8dc',
        crimson:'dc143c', cyan:'00ffff', darkblue:'00008b', darkcyan:'008b8b', darkgoldenrod:'b8860b',
        darkgray:'a9a9a9', darkgreen:'003200', darkkhaki:'bdb76b', darkmagenta:'8b008b', darkolivegreen:'556b2f',
        darkorange:'ff8c00', darkorchid:'9932cc', darkred:'8b0000', darksalmon:'e9967a', darkseagreen:'8fbc8f',
        darkslateblue:'323d8b', darkslategray:'2f4f4f', darkturquoise:'00ced1', darkviolet:'9400d3', deeppink:'ff1493',
        deepskyblue:'00bfff', dimgray:'696969', dodgerblue:'1e90ff', feldspar:'d19275', firebrick:'b22222',
        floralwhite:'fffaf0', forestgreen:'228b22', fuchsia:'ff00ff', gainsboro:'dcdcdc', ghostwhite:'f8f8ff',
        gold:'ffd700', goldenrod:'daa520', gray:'808080', green:'008000', greenyellow:'adff2f', honeydew:'f0fff0',
        hotpink:'ff69b4', indianred :'cd5c5c', indigo :'4b0082', ivory:'fffff0', khaki:'f0e68c', lavender:'e6e6fa',
        lavenderblush:'fff0f5', lawngreen:'7cfc00', lemonchiffon:'fffacd', lightblue:'add8e6', lightcoral:'f08080',
        lightcyan:'e0ffff', lightgoldenrodyellow:'fafad2', lightgrey:'d3d3d3', lightgreen:'90ee90', lightpink:'ffb6c1',
        lightsalmon:'ffa07a', lightseagreen:'20b2aa', lightskyblue:'87cefa', lightslateblue:'8470ff', lightslategray:'778899',
        lightsteelblue:'b0c4de', lightyellow:'ffffe0', lime:'00ff00', limegreen:'32cd32', linen:'faf0e6',
        magenta:'ff00ff', maroon:'800000', mediumaquamarine:'66cdaa', mediumblue:'0000cd', mediumorchid:'ba55d3',
        mediumpurple:'9370d8', mediumseagreen:'3cb371', mediumslateblue:'7b68ee', mediumspringgreen:'00fa9a', mediumturquoise:'32d1cc',
        mediumvioletred:'c71585', midnightblue:'191970', mintcream:'f5fffa', mistyrose:'ffe4e1', moccasin:'ffe4b5',
        navajowhite:'ffdead', navy:'000080', oldlace:'fdf5e6', olive:'808000', olivedrab:'6b8e23', orange:'ffa500',
        orangered:'ff4500', orchid:'da70d6', palegoldenrod:'eee8aa', palegreen:'98fb98', paleturquoise:'afeeee',
        palevioletred:'d87093', papayawhip:'ffefd5', peachpuff:'ffdab9', peru:'cd853f', pink:'ffc0cb',
        plum:'dda0dd', powderblue:'b0e0e6', purple:'800080', red:'ff0000', rosybrown:'bc8f8f', royalblue:'4169e1',
        saddlebrown:'8b4513', salmon:'fa8072', sandybrown:'f4a460', seagreen:'2e8b57', seashell:'fff5ee',
        sienna:'a0522d', silver:'c0c0c0', skyblue:'87ceeb', slateblue:'6a5acd', slategray:'708090', snow:'fffafa',
        springgreen:'00ff7f', steelblue:'4682b4', tan:'d2b32c', teal:'008080', thistle:'d8bfd8', tomato:'ff6347',
        turquoise:'40e0d0', violet:'ee82ee', violetred:'d02090', wheat:'f5deb3', white:'ffffff', whitesmoke:'f5f5f5',
        yellow:'ffff00', yellowgreen:'9acd32'
  };
  for (var key in simple_colors) if (s==key) s=simple_colors[key];

  var color_defs = [
    { re: /^rgb\((\d{1,3}),\s*(\d{1,3}),\s*(\d{1,3})\)$/,  //rgb(r,g,b)
      process: function (bits){return {'r':parseInt(bits[1]),'g':parseInt(bits[2]),'b':parseInt(bits[3])};}
    },
    { re: /^(\w{2})(\w{2})(\w{2})$/,  // 12a79c
      process: function (bits){return {'r':parseInt(bits[1], 16), 'g':parseInt(bits[2], 16), 'b':parseInt(bits[3], 16)};}
    },
    { re: /^(\w{1})(\w{1})(\w{1})$/,  // fe
      process: function (bits){return {'r':parseInt(bits[1] + bits[1], 16), 'g':parseInt(bits[2] + bits[2], 16), 'b':parseInt(bits[3] + bits[3], 16)};}
    }
  ];

  for (var i = 0; i < color_defs.length; i++)
  { var bits = color_defs[i].re.exec(s);
    if (bits) 
    { var t = color_defs[i].process(bits);
      t.r = (t.r < 0 || isNaN(t.r)) ? 0 : ((t.r > 255) ? 255 : t.r);
      t.g = (t.g < 0 || isNaN(t.g)) ? 0 : ((t.g > 255) ? 255 : t.g);
      t.b = (t.b < 0 || isNaN(t.b)) ? 0 : ((t.b > 255) ? 255 : t.b);
      return t;
    }
  }
  return null;
}

function colorjoin(r)
{ var t = {'r':r.r, 'g':r.g, 'b':r.b};
  t.r = (t.r < 0 || isNaN(t.r)) ? 0 : ((t.r > 255) ? 255 : t.r);
  t.g = (t.g < 0 || isNaN(t.g)) ? 0 : ((t.g > 255) ? 255 : t.g);
  t.b = (t.b < 0 || isNaN(t.b)) ? 0 : ((t.b > 255) ? 255 : t.b);
  return 'rgb('+t.r+','+t.g+','+t.b+')';
}

var htmlentities = [
['\u00A0','&nbsp;'    ], ['\u0152','&OElig;'   ], ['\u0153','&oelig;'   ], 
['\u0160','&Scaron;'  ], ['\u0161','&scaron;'  ], ['\u0178','&Yuml;'    ], 
['\u02C6','&circ;'    ], ['\u02DC','&tilde;'   ], ['\u2002','&ensp;'    ], 
['\u2003','&emsp;'    ], ['\u2009','&thinsp;'  ], ['\u200C','&zwnj;'    ], 
['\u200D','&zwj;'     ], ['\u200E','&lrm;'     ], ['\u200F','&rlm;'     ], 
['\u2013','&ndash;'   ], ['\u2014','&mdash;'   ], ['\u2018','&lsquo;'   ], 
['\u2019','&rsquo;'   ], ['\u201A','&sbquo;'   ], ['\u201C','&ldquo;'   ], 
['\u201D','&rdquo;'   ], ['\u201E','&bdquo;'   ], ['\u2020','&dagger;'  ], 
['\u2021','&Dagger;'  ], ['\u2030','&permil;'  ], ['\u2039','&lsaquo;'  ], 
['\u203A','&rsaquo;'  ], ['\u20AC','&euro;'    ], ['\u0192','&fnof;'    ], 
['\u0391','&Alpha;'   ], ['\u0392','&Beta;'    ], ['\u0393','&Gamma;'   ], 
['\u0394','&Delta;'   ], ['\u0395','&Epsilon;' ], ['\u0396','&Zeta;'    ], 
['\u0397','&Eta;'     ], ['\u0398','&Theta;'   ], ['\u0399','&Iota;'    ], 
['\u039A','&Kappa;'   ], ['\u039B','&Lambda;'  ], ['\u039C','&Mu;'      ], 
['\u039D','&Nu;'      ], ['\u039E','&Xi;'      ], ['\u039F','&Omicron;' ], 
['\u03A0','&Pi;'      ], ['\u03A1','&Rho;'     ], ['\u03A3','&Sigma;'   ], 
['\u03A4','&Tau;'     ], ['\u03A5','&Upsilon;' ], ['\u03A6','&Phi;'     ], 
['\u03A7','&Chi;'     ], ['\u03A8','&Psi;'     ], ['\u03A9','&Omega;'   ], 
['\u03B1','&alpha;'   ], ['\u03B2','&beta;'    ], ['\u03B3','&gamma;'   ], 
['\u03B4','&delta;'   ], ['\u03B5','&epsilon;' ], ['\u03B6','&zeta;'    ], 
['\u03B7','&eta;'     ], ['\u03B8','&theta;'   ], ['\u03B9','&iota;'    ], 
['\u03BA','&kappa;'   ], ['\u03BB','&lambda;'  ], ['\u03BC','&mu;'      ], 
['\u03BD','&nu;'      ], ['\u03BE','&xi;'      ], ['\u03BF','&omicron;' ], 
['\u03C0','&pi;'      ], ['\u03C1','&rho;'     ], ['\u03C2','&sigmaf;'  ], 
['\u03C3','&sigma;'   ], ['\u03C4','&tau;'     ], ['\u03C5','&upsilon;' ], 
['\u03C6','&phi;'     ], ['\u03C7','&chi;'     ], ['\u03C8','&psi;'     ], 
['\u03C9','&omega;'   ], ['\u03D1','&thetasym;'], ['\u03D2','&upsih;'   ], 
['\u03D6','&piv;'     ], ['\u2022','&bull;'    ], ['\u2026','&hellip;'  ], 
['\u2032','&prime;'   ], ['\u2033','&Prime;'   ], ['\u203E','&oline;'   ], 
['\u2044','&frasl;'   ], ['\u2118','&weierp;'  ], ['\u2111','&image;'   ], 
['\u211C','&real;'    ], ['\u2122','&trade;'   ], ['\u2135','&alefsym;' ], 
['\u2190','&larr;'    ], ['\u2191','&uarr;'    ], ['\u2192','&rarr;'    ], 
['\u2193','&darr;'    ], ['\u2194','&harr;'    ], ['\u21B5','&crarr;'   ], 
['\u21D0','&lArr;'    ], ['\u21D1','&uArr;'    ], ['\u21D2','&rArr;'    ], 
['\u21D3','&dArr;'    ], ['\u21D4','&hArr;'    ], ['\u2200','&forall;'  ], 
['\u2202','&part;'    ], ['\u2203','&exist;'   ], ['\u2205','&empty;'   ], 
['\u2207','&nabla;'   ], ['\u2208','&isin;'    ], ['\u2209','&notin;'   ], 
['\u220B','&ni;'      ], ['\u220F','&prod;'    ], ['\u2211','&sum;'     ], 
['\u2212','&minus;'   ], ['\u2217','&lowast;'  ], ['\u221A','&radic;'   ], 
['\u221D','&prop;'    ], ['\u221E','&infin;'   ], ['\u2220','&ang;'     ], 
['\u2227','&and;'     ], ['\u2228','&or;'      ], ['\u2229','&cap;'     ], 
['\u222A','&cup;'     ], ['\u222B','&int;'     ], ['\u2234','&there4;'  ], 
['\u223C','&sim;'     ], ['\u2245','&cong;'    ], ['\u2248','&asymp;'   ], 
['\u2260','&ne;'      ], ['\u2261','&equiv;'   ], ['\u2264','&le;'      ], 
['\u2265','&ge;'      ], ['\u2282','&sub;'     ], ['\u2283','&sup;'     ], 
['\u2284','&nsub;'    ], ['\u2286','&sube;'    ], ['\u2287','&supe;'    ], 
['\u2295','&oplus;'   ], ['\u2297','&otimes;'  ], ['\u22A5','&perp;'    ], 
['\u22C5','&sdot;'    ], ['\u2308','&lceil;'   ], ['\u2309','&rceil;'   ], 
['\u230A','&lfloor;'  ], ['\u230B','&rfloor;'  ], ['\u2329','&lang;'    ], 
['\u232A','&rang;'    ], ['\u25CA','&loz;'     ], ['\u2660','&spades;'  ], 
['\u2663','&clubs;'   ], ['\u2665','&hearts;'  ], ['\u2666','&diams;'   ], 
['\u00A1','&iexcl;'   ], ['\u00A2','&cent;'    ], ['\u00A3','&pound;'   ], 
['\u00A4','&curren;'  ], ['\u00A5','&yen;'     ], ['\u00A6','&brvbar;'  ], 
['\u00A7','&sect;'    ], ['\u00A8','&uml;'     ], ['\u00A9','&copy;'    ], 
['\u00AA','&ordf;'    ], ['\u00AB','&laquo;'   ], ['\u00AC','&not;'     ], 
['\u00AD','&shy;'     ], ['\u00AE','&reg;'     ], ['\u00AF','&macr;'    ], 
['\u00B0','&deg;'     ], ['\u00B1','&plusmn;'  ], ['\u00B2','&sup2;'    ], 
['\u00B3','&sup3;'    ], ['\u00B4','&acute;'   ], ['\u00B5','&micro;'   ], 
['\u00B6','&para;'    ], ['\u00B7','&middot;'  ], ['\u00B8','&cedil;'   ], 
['\u00B9','&sup1;'    ], ['\u00BA','&ordm;'    ], ['\u00BB','&raquo;'   ], 
['\u00BC','&frac14;'  ], ['\u00BD','&frac12;'  ], ['\u00BE','&frac34;'  ], 
['\u00BF','&iquest;'  ], ['\u00C0','&Agrave;'  ], ['\u00C1','&Aacute;'  ], 
['\u00C2','&Acirc;'   ], ['\u00C3','&Atilde;'  ], ['\u00C4','&Auml;'    ], 
['\u00C5','&Aring;'   ], ['\u00C6','&AElig;'   ], ['\u00C7','&Ccedil;'  ], 
['\u00C8','&Egrave;'  ], ['\u00C9','&Eacute;'  ], ['\u00CA','&Ecirc;'   ], 
['\u00CB','&Euml;'    ], ['\u00CC','&Igrave;'  ], ['\u00CD','&Iacute;'  ], 
['\u00CE','&Icirc;'   ], ['\u00CF','&Iuml;'    ], ['\u00D0','&ETH;'     ], 
['\u00D1','&Ntilde;'  ], ['\u00D2','&Ograve;'  ], ['\u00D3','&Oacute;'  ], 
['\u00D4','&Ocirc;'   ], ['\u00D5','&Otilde;'  ], ['\u00D6','&Ouml;'    ], 
['\u00D7','&times;'   ], ['\u00D8','&Oslash;'  ], ['\u00D9','&Ugrave;'  ], 
['\u00DA','&Uacute;'  ], ['\u00DB','&Ucirc;'   ], ['\u00DC','&Uuml;'    ], 
['\u00DD','&Yacute;'  ], ['\u00DE','&THORN;'   ], ['\u00DF','&szlig;'   ], 
['\u00E0','&agrave;'  ], ['\u00E1','&aacute;'  ], ['\u00E2','&acirc;'   ], 
['\u00E3','&atilde;'  ], ['\u00E4','&auml;'    ], ['\u00E5','&aring;'   ], 
['\u00E6','&aelig;'   ], ['\u00E7','&ccedil;'  ], ['\u00E8','&egrave;'  ], 
['\u00E9','&eacute;'  ], ['\u00EA','&ecirc;'   ], ['\u00EB','&euml;'    ], 
['\u00EC','&igrave;'  ], ['\u00ED','&iacute;'  ], ['\u00EE','&icirc;'   ], 
['\u00EF','&iuml;'    ], ['\u00F0','&eth;'     ], ['\u00F1','&ntilde;'  ], 
['\u00F2','&ograve;'  ], ['\u00F3','&oacute;'  ], ['\u00F4','&ocirc;'   ], 
['\u00F5','&otilde;'  ], ['\u00F6','&ouml;'    ], ['\u00F7','&divide;'  ], 
['\u00F8','&oslash;'  ], ['\u00F9','&ugrave;'  ], ['\u00FA','&uacute;'  ], 
['\u00FB','&ucirc;'   ], ['\u00FC','&uuml;'    ], ['\u00FD','&yacute;'  ], 
['\u00FE','&thorn;'   ], ['\u00FF','&yuml;'    ]
];

function ampersandise(s)
{ for (var i=0; i<htmlentities.length; i++)
  { var re = new RegExp(); re.compile(htmlentities[i][0],'g');
    s = s.replace(re,htmlentities[i][1]);
  }
  return s;
}

function unampersandise(s)
{ for (var i=0; i<htmlentities.length; i++)
  { var re = new RegExp(); re.compile(htmlentities[i][1],'g');
    s = s.replace(re,htmlentities[i][0]);
  }
  return s;
}

function code_markup(src)
{ var dst = "";
  var delims = " \t\r\n!@#$%^&*()-_=+[{]}\\|;:'\",<.>/?";
  src = src.replace(/\r\n/g,'\n').replace(/\r/g,'\n');
  // we turn &<> into &amp;&lt;&gt; now, because after we've added
  // our own <span> directives it'll be too late.
  src = src.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;");
  var re = [
    ['/*', /^(\/\*(.|[\r\n])*?\*\/)/, '<span style="color:green; font-style:italic;">$1</span>'],
//    ['(*', /^\(\*(.|[\r\n])*?\*\)/, '<span style="color:green; font-style:italic;">$1</span>'],
    ['&lt;!--', /^(&lt;!--(.|[\r\n])*?--&gt;)/, '<span style="color:green; font-style:italic;">$1</span>'],
    ['//', /^(\/\/.*)/, '<span style="color:green; font-style:italic;">$1</span>'],
    ['\n#', /^\n(# *[^ \r\n]*)(.*)/, '\n<span style="color:blue;">$1</span>$2'],
    ['"', /^("((\\.)|[^\\"\r\n])*")/, '<span style="color:rgb(140,0,40);">$1</span>'],
    ['\'',/^('((\\.)|[^\\'\r\n])*')/, '<span style="color:rgb(140,0,40);">$1</span>'],
    ['/', /^(\/((\\\/)|[^\/\r\n])*\/[gi]*)/, '<span style="color:rgb(140,0,140);">$1</span>'],
    ['$', /^(\$[a-zA-Z_]*)/, '<span style="color:rgb(100,10,140);font-style:italic;">$1</span>'],
    ['&lt;/', /^(&lt;\/[a-zA-Z]*&gt;)/, '<span style="color:black;font-weight:bold;">$1</span>'],
    ['&lt;', /^&lt;([a-zA-Z]*)((("((\\")|[^"\r\n])*")|('((\\')|[^'\r\n])*')|[a-zA-Z =\r\n])*?)(\/?&gt;)/, '<span style="color:black;font-weight:bold;">&lt;$1</span><span style="color:rgb(60,60,120);">$2</span><span style="color:black;font-weight:bold;">$10</span>'],
    ['=&gt;', /^(=&gt;)/, '<span style="color:rgb(120,120,120);">=&gt;</span>'],
    ['0', /^(\d*)/, '<span style="color:rgb(0,10,100);">$1</span>'],
    ['1', /^(\d*)/, '<span style="color:rgb(0,10,100);">$1</span>'],
    ['2', /^(\d*)/, '<span style="color:rgb(0,10,100);">$1</span>'],
    ['3', /^(\d*)/, '<span style="color:rgb(0,10,100);">$1</span>'],
    ['4', /^(\d*)/, '<span style="color:rgb(0,10,100);">$1</span>'],
    ['5', /^(\d*)/, '<span style="color:rgb(0,10,100);">$1</span>'],
    ['6', /^(\d*)/, '<span style="color:rgb(0,10,100);">$1</span>'],
    ['7', /^(\d*)/, '<span style="color:rgb(0,10,100);">$1</span>'],
    ['8', /^(\d*)/, '<span style="color:rgb(0,10,100);">$1</span>'],
    ['9', /^(\d*)/, '<span style="color:rgb(0,10,100);">$1</span>'],
  ];
  var keys = [
    [['let','val','echo','exit','array','function','var','while','do','else','new','sizeof','try','catch','finally','return','if','break','continue','for','volatile','inline','const','class','private:','public','public:','protected:'], '<span style="color:black; font-weight:bold;">$1</span>'],
    [['null','true','false','S_OK'],  '<span style="color:rgb(0,10,100);">$1</span>'],
    [['long','HRESULT','STDMETHODCALLTYPE','DWORD','WINAPI','BOOL','STDAPI','void','char','int','bool','HANDLE'], '<span style="color:blue;">$1</span>'],
  ];
  for (var i=0; i<keys.length; i++)
  { if (!keys[i]) continue;
    var r = keys[i][1]+"$2";
    for (var j=0; j<keys[i][0].length; j++)
    { var s=keys[i][0][j];
      var e="^("+s+")([\\s!\\*\\(\\)\\[\\];])";
      re.push([s, e, r]);
    }
  }
  src="\n"+src+"\n";
  outer: while (src.length>0)
  { // Find the first things that matched our cheap test
    var mpos=-1, mii=[];
    for (var i=0; i<re.length; i++)
    { if (!re[i]) continue;
      var m=src.indexOf(re[i][0]); if (m==-1) continue;
      if (m<mpos || mpos==-1) {mpos=m; mii=[i];} else if (m==mpos) mii.push(i);
    }
    if (mii.length==0) {dst+=src; src=""; break;}
    if (mpos>0 && delims.indexOf(src.charAt(mpos))==-1 && delims.indexOf(src.charAt(mpos-1))==-1) {dst+=src.substring(0,mpos+1); src=src.substring(mpos+1); continue outer;}
    // Find if any of those first things match our more expensive test
    inner: for (var i=0; i<mii.length; i++)
    { var mi=mii[i];
      m = src.substring(mpos).match(re[mi][1]);
      if (!m) continue inner;
      var mr = re[mi][2].split('$');
      for (var j=1; j<mr.length; j++)
      { var m2=mr[j].match(/^(\d*)(.*)$/);
        if (m2) mr[j]=m[parseInt(m2[1])]+m2[2]; else mr[j]='$'+mr[j];
      }
      dst+=src.substring(0,mpos)+mr.join('');
      src=src.substring(mpos+m[0].length);
      continue outer;
    }
    // otherwise, proceed to the next delimeter
    dst+=src.substring(0,mpos+1); src=src.substring(mpos+1);
  }
  dst = ampersandise(dst); // to turn e.g. a dagger into $dagger;
  dst = dst.replace(/^[\r\n]*((.|[\r\n])*?)[\r\n]*$/,'$1');
  return dst;
}

function code_markdown(src)
{ src = src.replace(/<[^>]+>/g,'').replace(/&nbsp;/g,' ').replace(/&gt;/g,'>').replace(/&lt;/g,'<').replace(/&amp;/g,'&');
  src = unampersandise(src);
  return src;
}

function GetMeta()
{ var r={title:'', description:'', keywords:''};
  var head = document.getElementsByTagName("head")[0];
  var title = document.getElementsByTagName("title")[0];
  if (title) r.title = title.innerHTML;
  var metas = document.getElementsByTagName("meta");
  for (var i=0; i<metas.length; i++)
  { var name=metas[i].NAME; if (!name) name=metas[i].name; name=name?name.toLowerCase():'';
    var cont=metas[i].CONTENT; if (!cont) cont=metas[i].content; cont=cont?cont:'';
    if (name=='description') r.description=cont;
    else if (name=='keywords') r.keywords=cont;
  }
  return r;
}

function SetMeta(r)
{ var head = document.getElementsByTagName("head")[0];
  var title = document.getElementsByTagName("title")[0];
  if (title) title.text = r.title;
  else
  { title = document.createElement('title'); title.innerHTML=r.title;
    if (head.childNodes.length==0) head.appendChild(title); else head.insertBefore(title,head.childNodes[0]);
  }
  document.title = r.title;
  var metas = document.getElementsByTagName("meta"); var rems=[];
  for (var i=0; i<metas.length; i++)
  { var name = metas[i].name; name=name?name.toLowerCase():'';
    if (name=="description" || name=="keywords") rems.push(metas[i]);
  }
  for (var i=0; i<rems.length; i++) rems[i].parentNode.removeChild(rems[i]);
  var p=title.nextSibling; if (p.nodeName.toLowerCase()=="#comment") p=p.nextSibling;
  var desc=document.createElement("meta"); desc.setAttribute("NAME","description"); desc.name="description"; desc.setAttribute("CONTENT",r.description); desc.CONTENT=r.description; head.insertBefore(desc,p);
  var keyw=document.createElement("meta"); keyw.setAttribute("NAME","keywords"); keyw.name="keywords"; keyw.setAttribute("CONTENT", r.keywords); keyw.CONTENT=r.keywords; head.insertBefore(keyw,p);
}


function htmltidy(ss)
{ var accum = "";
  var s = ss.replace(/\r\n/g,'\n').replace(/\r/g,'\n');

  var stack=[]; var outstandingli=false;
  while (s.length>0)
  { var m = s.match(/^([^<]*)<((('((\\')|[^'])*')|("((\\")|[^"])*")|[^"'>])*)>/); if (!m) {accum+=s; break;}
    var cdata=m[1], tag=m[2], tags=[]; s=s.substring(m[0].length);

    // wrap text
    if (stack.length==0)
    { cdata = cdata.replace(/\n+/g,'\n');
      while (true)
      { var c1=cdata;
        cdata = cdata.replace(/^(............................................................\S*?) /gm, '$1\n');
        if (c1==cdata) break;
      }
    }

    while (tag.length>0)
    { m = tag.match(/^(\/)\s*/);
      if (!m) m = tag.match(/^([a-zA-Z0-9_:-]+)\s*=\s*(('((\\')|[^'])*')|("((\\")|[^"])*")|[^\s]*)\s*/);
      if (!m) m = tag.match(/^([a-zA-Z0-9_:-]+)\s*/);
      if (!m) return ss;
      tag=tag.substr(m[0].length); var key=m[1].toLowerCase(), val=m[2];
      if (val && val.substr(0,1)!='\'' && val.substr(0,1)!='\"') {if (val.indexOf('\"')==-1) val='\"'+val+'\"'; else if (val.indexOf('\'')==-1) val='\''+val+'\'';}
      if (key=='style')
      { var vals=[];
        val=val.replace(/^'(((\\')|[^'])*)'$/,'$1').replace(/^"(((\\")|[^"])*)"$/,'$1');
        while (val.length>0)
        { m = val.match(/^(([^;'"]|('((\\')|[^'])*')|("((\\")|[^"])*"))*);?/);
          if (!m) continue;
          var sv=m[1]; val=val.substr(m[0].length); 
          m = sv.match(/^\s*(.*?)\s*:\s*(.*?)\s*$/); if (!m) return "FAIL "+sv;
          var skey=m[1], sval=m[2]; if (!sval) sval='';
          skey = skey.toLowerCase();
          sval=sval.replace(/rgb\(\s*(\d*)\s*,\s*(\d*)\s*,\s*(\d*)\s*\)/g,'rgb($1,$2,$3)');
          vals.push([skey,sval]);
        }
        vals.sort(function(a,b){if (a[0]<b[0]) return -1; else if (a[0]>b[0]) return 1; else return 0;});   
        for (var k=0; k<vals.length; k++)
        { if (val.length+0) val+=' ';
          val+=vals[k][0]+':'+vals[k][1]+';';
        }
        if (val.indexOf('\"')==-1) val='\"'+val+'\"'; else if (val.indexOf('\'')==-1) val='\''+val+'\'';
      }
      tags.push([key,val]);
    }
    var closing1 = (tags[0][0]=='/'); if (closing1) tags.shift();
    var tagname=tags[0][0]; tag+=tagname; tags.shift();
    var pre = (tagname=="pre");
    var closing2 = (tags.length>0 && tags[tags.length-1][0]=='/'); if (closing2) tags.pop();
    if (tagname=='br' || tagname=='hr') closing2=true;
    tags.sort(function(a,b){if (a[0]==b[0]) return 0; else if (a[0]=='id') return -1; else if (b[0]=='id') return 1; else if (a[0]=='href')return -1; else if (b[0]=='href')return 1; else if (a[0]=='src') return -1; else if (b[0]=='src') return 1; else if (a[0]=='width') return -1; else if (b[0]=='width') return 1; else if (a[0]=='height') return -1; else if (b[0]=='height') return 1; else if (a[0]<b[0]) return -1; else return 1;})
    for (var i=0; i<tags.length; i++)
    { tag+=' '+tags[i][0]; if (tags[i][1]) tag+='='+tags[i][1];
      if (tags[i][0]=="style") pre |= tags[i][1].toLowerCase().indexOf("white-space")!=-1;
    }
    var opening = (!closing1 && !closing2);
    var closing = closing1;
    //
    if (closing1) tag='/'+tag;
    if (closing2) tag=tag+'/';
    //
    tag='<'+tag+'>';
    if (tagname=='li' && closing) cdata=cdata.replace(/\s*$/,'');
    if (!opening && (tagname=='ul' || tagname=='ol' || tagname=='br' || tagname=='hr')) cdata=cdata.replace(/\n*$/,'\n');
    if (outstandingli && tagname=='li' && opening) {tag='</li>\n'+tag; cdata=cdata.replace(/\s*$/,''); outstandingli=false;}
    accum+=cdata+tag;
    //
    if (pre) {if (opening) stack.push(tagname); else if (closing) stack.pop();}
    if (tagname=='li' && opening) outstandingli=true;
    if (tagname=='li' && closing) outstandingli=false;
    if ((tagname=='ul' || tagname=='ol') && closing) outstandingli=false;
    if ((tagname.match(/^h\d$/)) && opening && !pre) s='\n'+s;
  }
  //
  s = accum;
  s = s.replace(/(<br\/>)([^\n])/g,'$1\n$2');
  s = s.replace(/(<hr\/>)([^\n])/g,'$1\n$2');
  s = s.replace(/(<\/p>)([^\n])/g,'$1\n$2');
  s = s.replace(/(<\/li>)([^\n])/g,'$1\n$2');
  s = s.replace(/(<p>)\s*/g,'$1');
  s = s.replace(/(<h\d>)\s*/g,'$1');
  return s;
}



function fmt(s)
{ return s.replace(/ /g,'.').replace(/\r/g,'\\r').replace(/\n/g,'\\n\n');
}



function filter(i) {var s = "opacity:"+i+"; "; if (navigator.appName!="Netscape") s+="filter:alpha(opacity="+Math.floor(i*100+0.5)+"); zoom:1;"; return s;}



onEditableLoad();