<?php
// The Editable Web, (c) 2007 Lucian Wischik
// You're free to copy/use/modify/distribute this code in any way you
// want, without restriction. See end of file for usage documentation.

error_reporting(E_ALL|E_STRICT);
ini_set('display_errors','1');
$REQ = $_GET + $_POST;
if (function_exists('date_default_timezone_set')) date_default_timezone_set("UTC");
header("Content-type: text/plain");

function exitmsg($status,$msg)
{ header("HTTP/1.1 ".$status); echo $msg; exit();
}

function ensure($name,$isset)
{ if (!$isset) exitmsg("400 Bad request","Need ".$name."=");
}

function fmt($o)
{ $s = $o; //print_r($o,TRUE);
  return str_replace(array("&","<",">"," ","\n","\r"),array("+","(",")",".","\\n\n","\\r\n"),$s);
}

function write_file($fn, $s)
{ $f=@fopen($fn,"w");
  if (!$f) exitmsg("500 Server error","Failure writing '".$fn."'");
  $res = @flock($f,LOCK_EX);
  if (!$res) exitmsg("500 Server error","Failure locking '".$fn."'");
  fwrite($f,$s);
  fclose($f);
}

function tagStart($tagname,$tagstart,$tagend,$depth,&$xpath)
{ $x=&$xpath;
  foreach ($depth as $d) $x=&$x[$d][sizeof($x[$d])-1];
  if (!isset($x[$tagname])) $x[$tagname]=array();
  array_push($x[$tagname],array('.innerStart'=>$tagend, '.outerStart'=>$tagstart));
}

function tagEnd($tagname,$tagstart,$tagend,$depth,&$xpath)
{ $x=&$xpath;
  foreach ($depth as $d) $x=&$x[$d][sizeof($x[$d])-1];
  $x=&$x[$tagname][sizeof($x[$tagname])-1];
  $innerStart = $x['.innerStart']; $innerEnd=$tagstart;
  if ($innerEnd<$innerStart) $innerEnd=$innerStart; // for <tag/>
  $x['.innerEnd'] = $innerEnd; $x['.outerEnd']=$tagend;
}

// says whether there's an "a" followed only by "allow1/allow2/allow3"
function drpos($a,$depth,$allow1="x",$allow2="x",$allow3="x")
{ $pos=sizeof($depth)-1;
  while ($pos>0 && $depth[$pos]!=$a && ($depth[$pos]==$allow1 || $depth[$pos]==$allow2 || $depth[$pos]==$allow3)) $pos--;
  if ($pos!=-1 && $depth[$pos]==$a) return true; else return false;
}

function parse_html($s)
{ $depth=array(); $xpath=array();
  for ($spos=0; preg_match('/^([^<]*)(<(("((\\\\")|[^"])*")|(\'((\\\\\')|[^\'])*\')|[^>])*>)/',$s,$m); )
  { $tag=$m[2]; $tagstart=$spos+strlen($m[1]); $tagend=$tagstart+strlen($tag);
    $s=substr($s,$tagend-$spos); $spos=$tagend;
    if (!preg_match('/^<(\/?)\s*([!a-zA-Z][a-zA-Z0-9]*)(.|[\r\n])*?(\/?)>$/',$tag,$m)) continue;
    $sl1=strlen($m[1])>0; $tagname=strtolower($m[2]); $sl2=strlen($m[4])>0;
    $opening=!$sl1 && !$sl2; $closing=$sl1 && !$sl2; $openclosing=!$sl1 && $sl2;
    if ($tagname=="script" && !$sl1 && !$sl2)
    { if (!preg_match('/^((("((\\\\")|[^"])*")|(\'((\\\\\')|[^\'])*\')|.|[\r\n])*?)<\/script/',$s,$m)) break;
      $spos+=strlen($m[1]); $s=substr($s,strlen($m[1]));
    }
    if ($opening || $openclosing)
    { if ($tagname=="head")
      { if (sizeof($depth)>0) exitmsg("500 Server error","Bad document has nested head element");
        tagStart($tagname,$tagstart,$tagend,$depth,$xpath); array_push($depth,$tagname);
      }
      else if ($tagname=="body")
      { if (sizeof($depth)>0) exitmsg("500 Server error","Bad document has nested body element");
        tagStart($tagname,$tagstart,$tagend,$depth,$xpath); array_push($depth,$tagname);
      }
      else if ($tagname=="div")
      { if (sizeof($depth)==0 || $depth[0]!="body") exitmsg("500 Server error","Bad document lacks body element");
        if (drpos("table",$depth)) exitmsg("500 Server error","Bad document has div directly inside a table");
        tagStart($tagname,$tagstart,$tagend,$depth,$xpath); array_push($depth,$tagname);
      }
      else if ($tagname=="pre")
      { if (sizeof($depth)==0 || $depth[0]!="body") exitmsg("500 Server error","Bad document lacks body element");
        if (drpos("table",$depth)) exitmsg("500 Server error","Bad document has pre directly inside a table");
        if (drpos("pre",$depth)) exitmsg("500 Server error","Bad document has pre inside a pre");
        tagStart($tagname,$tagstart,$tagend,$depth,$xpath); array_push($depth,$tagname);
      }
      else if ($tagname=="table")
      { if (sizeof($depth)==0 || $depth[0]!="body") exitmsg("500 Server error","Bad document lacks body element");
        if (drpos("table",$depth)) exitmsg("500 Server error","Bad document has table directly inside a table");
        if (drpos("pre",$depth)) tagEnd(array_pop($depth),$tagstart,$tagstart,$depth,$xpath);
        tagStart($tagname,$tagstart,$tagend,$depth,$xpath); array_push($depth,$tagname);
      }
      else if ($tagname=="td")
      { if (sizeof($depth)==0 || $depth[0]!="body") exitmsg("500 Server error","Bad document lacks body element");
        if (drpos("td",$depth,"pre","div")) while ($depth[sizeof($depth)-1]!="td") tagEnd(array_pop($depth),$tagstart,$tagstart,$depth,$xpath);
        if (drpos("td",$depth)) tagEnd(array_pop($depth),$tagstart,$tagstart,$depth,$xpath);
        if (drpos("table",$depth)) {tagStart($tagname,$tagstart,$tagend,$depth,$xpath); array_push($depth,$tagname);}
      }
      else if ($tagname=="tr")
      { if (drpos("td",$depth,"pre","div")) {while ($depth[sizeof($depth)-1]!="td") tagEnd(array_pop($depth),$tagstart,$tagstart,$depth,$xpath); tagEnd(array_pop($depth),$tagstart,$tagstart,$depth,$xpath);}
      }
    }
    if ($closing || $openclosing)
    { if ($tagname=="head")
      { if (sizeof($depth)==1 && $depth[0]=='head') tagEnd(array_pop($depth),$tagstart,$tagend,$depth,$xpath);
        else exitmsg("500 Server error","Bad document has wrong head closing tag");
      }
      else if ($tagname=="body")
      { if (sizeof($depth)==1 && $depth[0]=='body') tagEnd(array_pop($depth),$tagstart,$tagend,$depth,$xpath);
        else exitmsg("500 Server error","Bad document hsa wrong body closing tag");
      }
      else if ($tagname=="div")
      { if (drpos("div",$depth,"pre")) while ($depth[sizeof($depth)-1]!="div") tagEnd(array_pop($depth),$tagstart,$tagstart,$depth,$xpath); 
        if (drpos("div",$depth)) tagEnd(array_pop($depth),$tagstart,$tagend,$depth,$xpath);
      }
      else if ($tagname=="pre")
      { if (drpos("pre",$depth,"div")) while ($depth[sizeof($depth)-1]!="pre") tagEnd(array_pop($depth),$tagstart,$tagstart,$depth,$xpath);
        if (drpos("pre",$depth)) tagEnd(array_pop($depth),$tagstart,$tagend,$depth,$xpath);
      }
      else if ($tagname=="table")
      { if (drpos("table",$depth,"pre","div","td")) while ($depth[sizeof($depth)-1]!="table") tagEnd(array_pop($depth),$tagstart,$tagstart,$depth,$xpath);
        if (drpos("table",$depth)) tagEnd(array_pop($depth),$tagstart,$tagend,$depth,$xpath);
      }
      else if ($tagname=="td")
      { if (drpos("td",$depth,"pre","div")) while ($depth[sizeof($depth)-1]!="td") tagEnd(array_pop($depth),$tagstart,$tagstart,$depth,$xpath);
        if (drpos("td",$depth)) tagEnd(array_pop($depth),$tagstart,$tagend,$depth,$xpath);
      }
      else if ($tagname=="tr")
      { if (drpos("td",$depth,"pre","div")) {while ($depth[sizeof($depth)-1]!="td") tagEnd(array_pop($depth),$tagstart,$tagstart,$depth,$xpath); tagEnd(array_pop($depth),$tagstart,$tagstart,$depth,$xpath);}
      }
    }
  }
  // and any closing tags
  $spos+=strlen($s);
  while (sizeof($depth)>0) tagEnd(array_pop($depth),$spos,$spos);
  return $xpath;
}

function get_tagpos($s,$xpath)
{ $doc = parse_html($s);
  $xpaths = preg_split('/\//',$xpath);
  $err="";
  foreach ($xpaths as $d)
  { if (strlen($err)>0) $err.="/"; $err.=$d;
    if (strlen($d)==0) continue;
    $b = preg_match('/^([a-z]*)\[(\d*)\]/',$d,$m);
    if (!$b) exitmsg("400 Bad request","Malformed path '$err'");
    if (!isset($doc[$m[1]])) exitmsg("400 Bad request","Tag doesn't exist '$err'");
    $doc = $doc[$m[1]];
    if ($m[2]>=sizeof($doc)) exitmsg("400 Bad request","There aren't that many tags '$err'");
    $doc = $doc[$m[2]];
  }
  return $doc;  
}

function notify($value,$email)
{ global $dr,$REQ;
  ensure('path',$REQ['path']);
  if (!isset($_SERVER['HTTP_REFERER'])) exitmsg("400 Bad request","Unknown referer");
  $npath=$REQ['path']; $nfile="editable_notify.txt"; $notifies=false;
  preg_match('/^http:\/\/(((www\.)?([^\/]*))\/.*)$/',$_SERVER['HTTP_REFERER'],$m);
  $npage=$m[1]; $ndomain=$m[2]; $nedomain=$m[4];
  while ($npath!="/" && !$notifies)
  { if (!@file_exists($dr.$npath.$nfile)) { $npath=preg_replace('/^(.*?\/)[^\/]*\/$/','$1',$npath); continue; }
    $notifies=@file($dr.$npath.$nfile);
    if (!$notifies) exitmsg("500 Server error","Error reading '".$npath.$nfile."'");
  }
  if ($notifies) foreach ($notifies as $notify)
  { $notify=trim($notify,"\r\n");
    if (preg_match('/\.xml$/i',$notify))
    { $s = @file_get_contents($dr.$npath.$notify);
      if (!$s) $s="<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n".
       "<rss version=\"2.0\" xmlns:dc=\"http://purl.org/dc/elements/1.1/\">\n".
       "<channel>\n".
       "<title>http://".$ndomain.$npath." changes</title>\n".
       "<link>http://".$ndomain.$npath.$notify."</link>\n".
       "<description>Changes</description>\n".
       "<lastBuildDate>".date("r")."</lastBuildDate>\n".
       "</channel>\n".
       "</rss>\n";
      $item = "<item>\n".
       "<title>".$npage." comment</title>\n".
       "<link>".$_SERVER['HTTP_REFERER']."</link>\n".
       "<description>".str_replace(array("<br/>","&amp;","&","<",">"),array("\n"," "," ","(",")"),$value)."</description>\n".
       "<pubDate>".date("r")."</pubDate>\n".
       "</item>";
      $s = preg_replace('/(<lastBuildDate>)[^<]*(<\/lastBuildDate>)/','$1'.date("r")."$2\n".$item, $s);
      write_file($dr.$npath.$notify, $s);
    }
    else if (preg_match('/\S@\S/',$notify))
    { $mailto = $notify;
      $mailsubject = "Editable ".$npage;
      $mailfrom = "From: editable@".$nedomain;
      $mailbody = GetHostByAddr($_SERVER['REMOTE_ADDR'])." - ".date("r")."\n".$_SERVER['HTTP_REFERER']."\n\n".$REQ['value'];
      if ($email)
      { $r = mail($mailto, $mailsubject, $mailbody, $mailfrom);
        if (!$r) exitmsg("500 Server error","Error sending email");
      }
    }
    else exitmsg("500 Server error","Unrecognized notify ".$notify);
  }
}


// *******************************************************

if (isset($REQ['path']))
{ $path = $REQ['path'];
  // The characters .. and ~ are potentially dangerous
  if (preg_match('/(\\.)|(\\.\\.)|~/',$path)) exitmsg("400 Bad reqest","Path '".$path."' not allowed");
  if ($path!='/' && !preg_match('/^\\/(.*)\\/$/',$path)) exitmsg("400 Bad request","Path '".$path."' needs leading and trailing slash");
  $dr = preg_replace("/^(.*)\\/$/","\${1}",$_SERVER['DOCUMENT_ROOT']);
   // that removed the trailing slash from document_root
  $path = $dr.$path;
  if (!@is_writable($path) || !@is_dir($path)) exitmsg("500 Server error","Directory '".$path."' is not writable by the webserver. chmod 777.");
}

if (isset($REQ['file']))
{ $file = $REQ['file'];
  if ($file=='') $file='index.html';
  ensure('path',isset($path));
  if ($file=='.' || $file=='..' || preg_match('/\\//',$file)) exitmsg("400 Bad reqest","File '".$file."' not allowed");
}

if (isset($REQ['value']))
{ $value = $REQ['value'];
  if (get_magic_quotes_gpc()) $value = preg_replace(array('/\\\\\'/','/\\\"/','/\\\\\\\\/'),array('\'','"','\\'), $value);
  // because the magic_quotes_gpc feature of PHP will have escaped slashes
}

if (isset($REQ['xpath']))
{ $xpath=$REQ['xpath'];
}

if (isset($REQ['innerouter']))
{ $innerouter=$REQ['innerouter'];
}



// ***********************************************************

if (isset($REQ['ip']))
{ echo GetHostByAddr($_SERVER['REMOTE_ADDR']);
  exit();
}


if (isset($REQ['pubset']))
{ ensure('file',isset($file));
  ensure('path',isset($path));
  ensure('xpath',isset($xpath));
  ensure('value',isset($value));
  ensure('innerouter',isset($innerouter));
  if ($innerouter!='inner') exitmsg("400 Bad request","innerouter must be 'inner'");
  if (!@is_file($path.$file)) exitmsg("400 Bad request","File '".$path.$file."' not found");
  if (!@is_writeable($path.$file)) exitmsg("500 Server error","File '".$path.$file."' not writable by the webserver. chmod 666.");
  $userip = GetHostByAddr($_SERVER['REMOTE_ADDR']);
  $old = @file_get_contents($path.$file);
  $tagpos = get_tagpos($old,$xpath);
  $innerStart=$tagpos['.innerStart']; $innerEnd=$tagpos['.innerEnd'];
  $outerStart=$tagpos['.outerStart']; $outerEnd=$tagpos['.outerEnd'];
  $tag = substr($old,$outerStart,$innerStart-$outerStart);
  $oldip = preg_match('/\sip="([^"]*)"/',$tag,$m);
  if (!$oldip) exitmsg("400 Bad request","This part is not publically editable.\n$tag");
  $oldip=$m[1]; if ($oldip!="*" && $oldip!=$userip) exitmsg("400 Bad request","This part '$oldip' is not editable by you '$userip'");

  // And here's how we prevent code-injection attacks:
  $value = str_replace(array("&","<",">","\r\n","\r","\n\n","\n"),array("&amp;","&lt;","&gt;","\n","\n","\n \n","<br/>"), $value);
  while (true)
  { $s=$value; $value=str_replace("<br/> ","<br/>&nbsp;",$value);
    if ($s==$value) break;
  }

  if ($oldip=="*") $new = substr($old,0,$outerStart)."<div ip=\"".htmlspecialchars($userip)."\" date=\"".htmlspecialchars(date("r"))."\" title=\"".htmlspecialchars("Posted by ".$userip." on ".date("r"))."\">".$value."</div>\n".substr($old,$outerStart);
  else $new = substr($old,0,$innerStart).$value.substr($old,$innerEnd);

  notify($value,true);
  write_file($path.$file,$new);
  
  echo "editable:set";
  exit();
}



if (!isset($hidebanner))
{ header("HTTP/1.1 400 Bad request");
  echo "EDITABLE WEB -- Ajax server\n".
       "0. ? -- prints usage instructions\n".
       "1. ?pubset&innerouter=inner&path=/lu/&file=a.html&xpath=/div[0]/div[0]&value=... -- modifies the file in DOCUMENT_ROOT/lu/a.html by replacing the contents of <div ip=\"1.2.3.4\">...</div> with value, which should have been uploaded in multipart/binary with no encoding. Returns 'editable:set'.\n".
       "2. ?ip -- returns the ip of the client machine.\n";
}
